/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : recover.c
 * Author : Clode@RevivalWorld
 * Date   : 2002-09-26
 * Note   : recover O
 * Update :
 *  o 2000-00-00
 *
 -----------------------------------------
 */

#include <ansi.h>
#include <feature.h>
#include <daemon.h>
#include <secure.h>
#include <message.h>

inherit COMMAND;

#define LOG	"command/recover"

string help = @HELP
	з recover OC
HELP;

private void command(object me, string arg)
{
	string path, option, msg;
	int overwrite, stat_time;
	int target_level_num, my_level_num;
	object target;
	
	if( !is_command() ) return;
	
	if( !arg ) 
		return tell(me, pnoun(2,me)+"Qn_ϥΪ̪ơH\n", CMDMSG);
	
	sscanf( arg, "%s -%s", arg, option );
	
	if( !option )
		return tell(me, "пJ -backup  -deleted ѼơC\n", CMDMSG);
	
	if( sscanf( option, "%s -overwrite", option ) == 1 ) overwrite = 1;

	target_level_num = SECURE_D->level_num(arg);
	my_level_num = SECURE_D->level_num(me->query_id(1));
	
	switch( option )
	{
		case "backup":
			if( file_size(path = user_backup_path(arg)) != -2 )
				return tell(me, "S "+arg+" oϥΪ̪ƥơC\n", CMDMSG);
			
			msg = me->query_idname()+"H "+TIME_D->replace_ctime(stat(path+"/data.o")[1])+" ƥɮרNF "+capitalize(arg)+" {ơC\n";
			
			if( file_size(user_path(arg)) == -2 )
			{
				if( overwrite )
				{
					if( my_level_num < target_level_num )
						return tell(me, pnoun(2,me)+"vHл\ "+arg+" {ϥΪ̸ơC\n", CMDMSG);
					else if( !sizeof(rmtree(user_path(arg))[0]) )
						return tell(me, pnoun(2,me)+"vLkR "+arg+" {ϥΪ̸ơC\n", CMDMSG);
					
				}
				else return tell(me, "Ynл\{ƥ[W -overwrite ѼơC\n", CMDMSG);
			}
			
			if( file_size(user_path(arg)) == -2 || !sizeof(cptree(path, user_path(arg))[0]) )
				return tell(me, "_ "+arg+" sɥѡC\n", CMDMSG);
			
			stat_time = stat(path+"/data.o")[1];
			
			break;
		case "deleted":
			if( file_size(path = user_deleted_path(arg)) != -2 )
				return tell(me, "S "+arg+" oϥΪ̪RƥơC\n", CMDMSG);
			
			
			
			msg = me->query_idname()+"NӧGǹЪɮ׫½F@MAשqtxs "+capitalize(arg)+" ƪϤAæw˦^tΤC\n";
			
			if( file_size(user_path(arg)) == -2 )
			{
				if( overwrite )
				{
					if( my_level_num < target_level_num )
						return tell(me, pnoun(2,me)+"vHл\ "+arg+" {ϥΪ̸ơC\n", CMDMSG);
					else if( !sizeof(rmtree(user_path(arg))[0]) )
						return tell(me, pnoun(2,me)+"vLkR "+arg+" {ϥΪ̸ơC\n", CMDMSG);
						
					rmtree(user_backup_path(arg));
				}
				else return tell(me, "Ynл\{ƥ[W -overwrite ѼơC\n", CMDMSG);
			}
			
			if( file_size(user_backup_path(arg)) == -2 || !sizeof(cptree(path, user_backup_path(arg))[0]) )
				return tell(me, "_ "+arg+" sɥѡC\n", CMDMSG);
				
			if( file_size(user_path(arg)) == -2 || !sizeof(cptree(path, user_path(arg))[0]) )
				return tell(me, "_ "+arg+" sɥѡC\n", CMDMSG);
			
			stat_time = stat(path+"/data.o")[1];
			
			rmtree(path);
			
			target = load_user(arg);
			
			PASSWORD_D->set_password(arg, copy(query("password", target)));
			
			delete("password", target);
			
			target->save();
			
			destruct(target);
			
			break;
		default:
			return tell(me, "пJ -backup  -deleted ѼơC\n", CMDMSG);
	}
	
	CHANNEL_D->channel_broadcast("news", msg);
	log_file(LOG, me->query_idname()+"_ "+arg+" b "+TIME_D->replace_ctime(stat_time)+" sɡC");
	
	if( objectp(target = find_player(arg)) ) 
	{
		tell(target, "\n"+me->query_idname()+"_F"+pnoun(2, me)+"b "+TIME_D->replace_ctime(stat_time)+" sɡC\n"HIY"ЭsnJsuC\n"NOR, CMDMSG);
		destruct(target);
	}
}	