/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : setip.c
 * Author : Clode@RevivalWorld
 * Date   : 2005-04-12
 * Note   : setip O
 * Update :
 *  o 2000-00-00  
 *
 -----------------------------------------
 */

#include <ansi.h>
#include <ip.h>
#include <daemon.h>
#include <feature.h>
#include <message.h>

inherit COMMAND;

string help = @HELP
setip 					- CXثe IP ]w
setip ban 210.59.67.253			- ]w IP ä[TnJ
setip ban 210.59.*.*			- ]w IP ä[TnJ
setip ban 210.59.*.* in 50		- ]w 50 pɤT IP nJ
setip ban 210.59.*.* in 50 with ''	- ]w 50 pɤT IP nJPɵѸ
setip -d 210.59.67.253			-  IP Ҧ]w

IP ܦi regexp Wyk

setip ﶵpU
 ban 		- T IP nJ
 cmdlimit	- Ѧ IP nJaOt(g@ʭ)
 ok		- Щ IP ݦXk IP, ݭn]w(KQЭ)
HELP;


int valid_ip(string ip)
{
	string *elem = allocate(4);
	
	if( sscanf(ip, "%s.%s.%s.%s", elem[0], elem[1], elem[2], elem[3]) != 4 )
		return 0;

	// Ĥ@ * |y regexp P_~
	if( elem[0] == "*" ) return 0;

	foreach(string e in elem)
	if( e != "*" && to_int(e) < 0 && to_int(e) > 255 )
		return 0;
		
	return 1;
}

private void command(object me, string arg)
{
	int releasetime;
	string option, ip, note;

	if( !is_command() ) return;
	
	if( !arg )
	{
		string msg;
		mapping ipdata = IP_D->query_ipdata();
		mapping data;
		msg  = HIW"IP                ]w         ]wɶ         ɶ         \n"NOR;
		msg += WHT"wwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww\n"NOR;
		
		if( sizeof(ipdata) )
		foreach(ip in sort_array(keys(ipdata), 1))
		{
			data = ipdata[ip];
			switch(data["status"])
			{
				case BAN: 		option = HIR"TnJ"NOR; break;
				case CMDLIMIT:		option = HIY"Ot׭"NOR; break;
				case OK:		option = HIG"Xk"NOR;	break;
			}
			msg += sprintf("%-18s%-13s"HIM"%-17s"NOR MAG"%-17s"NOR"%s\n", ip, option, TIME_D->replace_ctime(data["recordtime"]), data["releasetime"] ? TIME_D->replace_ctime(data["releasetime"]) : "L", data["note"]||"");
		}
		else
			msg += "S IP ]wC\n";
		msg += WHT"wwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww\n"NOR;
		return me->more(msg);
	}
	
	if( sscanf(arg, "%s %s", option, arg) != 2 )
		return tell(me, " help setip dߥTO榡C\n");
		
	if( sscanf(arg, "%s in %d with %s", ip, releasetime, note) != 3 && sscanf(arg, "%s in %d", ip, releasetime) != 2 && sscanf(arg, "%s with %s", ip, note) != 2 )
		ip = arg;

	if( !valid_ip(ip) )
		return tell(me, "IP 榡~C\n");

	switch(option)
	{
		case "ban":
			if( IP_D->query_ip(ip) )
				return tell(me, "IPu"+ip+"vw]wAХR]wC\n");

			IP_D->set_ip(me, ip, BAN, releasetime*3600);
			
			if( releasetime )
				CHANNEL_D->channel_broadcast("sys", me->query_idname()+"]w "+releasetime+" pɤTagѡu"+ip+"v IP mnJCC");
			else
				CHANNEL_D->channel_broadcast("sys", me->query_idname()+"]wä[Tagѡu"+ip+"v IP mnJCC");
			if( note )
			{
				IP_D->set_ip_note(me, ip, note);
				CHANNEL_D->channel_broadcast("sys", me->query_idname()+"Х IPu"+ip+"v]wѬG"+note+"C");
			}
			break;
		case "cmdlimit":
			if( IP_D->query_ip(ip) )
				return tell(me, "IPu"+ip+"vw]wAХR]wC\n");

			IP_D->set_ip(me, ip, CMDLIMIT, releasetime*3600);
			
			if( releasetime )
				CHANNEL_D->channel_broadcast("sys", me->query_idname()+"]w "+releasetime+" pɤgѡu"+ip+"v IP mnJaOtסC");
			else
				CHANNEL_D->channel_broadcast("sys", me->query_idname()+"]wä[gѡu"+ip+"v IP mnJaOtסC");
			if( note )
			{
				IP_D->set_ip_note(me, ip, note);
				CHANNEL_D->channel_broadcast("sys", me->query_idname()+"Х IPu"+ip+"v]wѬG"+note+"C");
			}
			break;
		case "ok":
			if( IP_D->query_ip(ip) )
				return tell(me, "IPu"+ip+"vw]wAХR]wC\n");
				
			IP_D->set_ip(me, ip, OK, releasetime*3600);
			
			if( releasetime )
				CHANNEL_D->channel_broadcast("sys", me->query_idname()+"]w "+releasetime+" pɤu"+ip+"v IP mӦXkLC");
			else
				CHANNEL_D->channel_broadcast("sys", me->query_idname()+"]wu"+ip+"v IP mӦXkLC");
			
			if( note )
			{
				IP_D->set_ip_note(me, ip, note);
				CHANNEL_D->channel_broadcast("sys", me->query_idname()+"Х IPu"+ip+"v]wѬG"+note+"C");
			}
			break;	
		case "-d":
			if( !IP_D->query_ip(ip) )
				return tell(me, "IPu"+ip+"v쥻NS󭭨]wC\n");
				
			IP_D->delete_ip(me, ip);
			CHANNEL_D->channel_broadcast("sys", me->query_idname()+" IPu"+ip+"vҦ]wC");
			break;
		default:
			return tell(me, "S "+option+" oӳ]wﶵC\n");	
	}	
}