/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : blist.c
 * Author : Clode@RevivalWorld
 * Date   : 2002-09-14
 * Note   : aO{
 * Update :
 *  o 2000-00-00  
 *
 -----------------------------------------
 */

#include <map.h>
#include <ansi.h>
#include <feature.h>
#include <daemon.h>
#include <message.h>
#include <roommodule.h>

inherit COMMAND;

string generate_building_list();

string help = @HELP
 ؿvC                                                           [blist]

      oӫOiHAݨثeRW̶}񪺫ؿvAHέn}ioؿvһݪ̧C
  CAnسy([1;33mbuild[m) KXAӥBn@HWC

      AU[1;33mblist[m ɡA|X{pUeG
HELP + generate_building_list()+ @HELP

  DBW١G
          NOoؿvDn\ΡAYOݤ^... ݥLW٤]jiHF
      ѥLDnOaH

  D̤֩жG
          ]Ab̤֮ƭAҦp[1;36mp[mөnF... ̤֩ж
      O@Aդ@INOAoREaCbKaW\W[1m[mAѤUզ⪺@
      A~iH}i([1;33mopen[m)A[1;36mp[mөC

          Hϥ|ҪܡG
        
        ṳ֩жvҺ⪺ƶq
        nӻ\ΪaC

          ̤֩ж = 3

      @     = 4    j̤֩жC
        
             = 12   ®ӻ\KXaC
      @

             MAܤ]iH\G
                                                        
                            
                            
                            
                                

          oMݭnRaiH֤@AƹW٬O򥿤Τ@ˡC

  DݩʡG
          ²檺NOAݪA@}lO[36mpH[m}lCӫiξ
      Цa@w{פiH}q][1;30m~[m^AΪ̬Ogѧ벼|Ӧ
      ][35mF[m^C

          ثe٥u[36mpH[mݩʡA[1;30m~[mM[35mF[mݩʥb}oAҥHLkԭzC

  DϰG
          b@}lɭԡAawgQFnFUإΦaCҦؿv
      ؿvFWnΦaWAǥuQؿvbYǥΦaWCpG[1;33mȦ[mAu}
      i[1;36;46mӷ~[mWF[1;36mp[mөhOTإΦaiH}iCCإΦaaPA
      bسyɶn`NC

  D}iOG
          AwgNHW@@FɡAb}ie̫@ӭANO}i
      OC]An\O@[1;36mp[mөAwbΦaWRFơAä@@سy
      XKX]]A^CAWnA~[1;33mopen store[mA}i
      A[1;36mp[mөC

[33m    O: build, open
[m
                                                            s@
HELP;



string generate_building_list()
{
        array data;
        string msg, buildingtype, buildingregion, *sortid;
        mapping building_table = BUILDING_D->query_building_table();
        string age;
	string *manual_sort = ({
		"cityhall",
		"recycle",
		"labor",
		"trading_post",
		"bank",
		"postoffice",
		"jail",
		"auction",
		"trainstation",
		"airport",
		"space",
		"nuclear",
		"prodigy",

		0,
		"enterprise",
		"stock",
		"university",
		0,
		"store",
		"warehouse",
		"house",
		"fence",
		"cabin",
		"expedition",
		"research",
		"resource",
		0,
		
		"metal",
		"stone",
		"water",
		"wood",
		"fuel",
		
		0,
		"food",
		"drink",
		"clothing",
		"instrument",
		"furniture",
		"hardware",
		"chemical",
		"machinery",
		"electrics",
		"transportation",
		"entertainment",
		"medicine",
		"adventure",
		"shortrange",
		"longrange",
		"armor",
		"heavyarmor",
		"magic",
	});

        sortid = manual_sort | keys(building_table);
       
       	msg = "ؿvCAثe@iسy "+sizeof(manual_sort-({0}))+" ثؿvG\n";
        msg += NOR WHT"wwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww\n"NOR;
        msg +=        "ؿv       W   ̤֩ж  W ca Ӽh     O/C ӭ  ɥN }\n";
        msg += NOR WHT"wwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww\n"NOR;
        
        
        foreach( string id in sortid )
        {
        	if( !stringp(id) )
        	{
        		msg += "\n";
        		continue;
        	}

                data = building_table[id];
                
                if( !data || !data[ROOMMODULE_OPENCOST] ) continue;
                
                if( data[ROOMMODULE_BUILDINGTYPE] & GOVERNMENT )
                        buildingtype = MAG"F"NOR;
                else if( data[ROOMMODULE_BUILDINGTYPE] & ENTERPRISE )
                        buildingtype = WHT""NOR;
                else if( data[ROOMMODULE_BUILDINGTYPE] & INDIVIDUAL )
                        buildingtype = CYN""NOR;
		
		switch(data[ROOMMODULE_AGE])
		{
			case 0: age = WHT"ve"NOR; break;
			case 1: age = HIG"A"NOR GRN"~"NOR; break;
			case 2: age = HIY"u"NOR YEL"~"NOR; break;
			case 3:	age = HIC""NOR CYN""NOR; break;
			case 4: age = HIB"t"NOR BLU"z"NOR; break;
			case 5: age = HIR""NOR RED""NOR; break;
		}

		if( data[ROOMMODULE_REGION] & AREA_REGION )
			buildingregion = HIW BGRN"  "NOR;
		else
                	buildingregion = ( data[ROOMMODULE_REGION] & AGRICULTURE_REGION ? HIG BGRN"A"NOR : "  ")+
					 ( data[ROOMMODULE_REGION] & INDUSTRY_REGION ? HIY BYEL"u"NOR : "  ")+
					 ( data[ROOMMODULE_REGION] & COMMERCE_REGION ? HIC BCYN""NOR : "  ");

                msg += sprintf("%-15s%-13s%2d %-3s%-7s%-5d%-4d%14s %|4s %|4s %4s %s\n", 
                        HIY+capitalize(id)+NOR, 
                        data[ROOMMODULE_SHORT],
                        data[ROOMMODULE_ROOMLIMIT],
                        buildingtype,
                        buildingregion,
                        data[ROOMMODULE_FLOURISH],
                        data[ROOMMODULE_MAXFLOOR],
                        HIW+NUMBER_D->number_symbol(data[ROOMMODULE_OPENCOST])+NOR,
                        NOR WHT+(data[ROOMMODULE_MAXLIMIT]||""),
                        NOR WHT+(data[ROOMMODULE_MAXBUILDINGLIMIT]||""),
                       	age,
                        data[ROOMMODULE_TESTING] ? HIR""NOR : HIG""NOR,
                        );
        }

        msg += NOR WHT"wwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww\n"NOR;
        
        
        return msg;
}


private void do_command(object me, string arg)
{
	me->more(generate_building_list());
}
