/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : bug.c
 * Author : Clode@RevivalWorld
 * Date   : 2001-2-5
 * Note   : bug O
 * Update :
 *  o 2000-00-00  
 *
 -----------------------------------------
 */

#include <ansi.h>
#include <daemon.h>
#include <feature.h>
#include <message.h>

inherit COMMAND;

#define PER_REPORT_TIME_LIMIT	60

#define LIST_OPT_ALL	(1<<0)

string help = @HELP

bug -a				sW bug ^
bug -l				CX bug 
bug [s]			Ū bug ԲӤe
bug -r [s]			^ bug Bz	ŮvM
bug -d [s]   		R bug Ҧ	ŮvM
bug -d [s] reply [s]	R bug Y@g^	ŮvM
bug				Ū~^		ŮvM
bug [ID]			ŪYH~^	ŮvM

HELP;

void edit_bug_content(object me, string title, string content)
{
	string number;
	
	if( time() - query_temp("bug_report", me) < PER_REPORT_TIME_LIMIT )
		return tell(me, pnoun(2, me)+"Aj "+(PER_REPORT_TIME_LIMIT + query_temp("bug_report", me) - time())+" ~A^@ BugC\n"NOR);
	
	number = BUG_D->add_bug(me, title, content);
	
	tell(me, HIY"P"+pnoun(2, me)+" Bug ^ϱooӥ@ɧ[C\n"NOR);
	tell(me, HIY"\nwN"+pnoun(2, me)+"Ҧ^ Bug sJƮwAs "+number+"AЧQ bug -l Hɪ`NBzpC\n"NOR);
	
	set_temp("bug_report", time(), me);
	
	me->finish_input();
}

void input_bug_title(object me, string title)
{
	if( !title || !title[0] )
	{
		tell(me, " Bug ^JC\n");
		return me->finish_input();
	}
	
	if( noansi_strlen(title) > 30 )
	{
		tell(me, "^DDoWL 30 ӦrC\n");
		return me->finish_input();
	}
	
	if( query("encode/gb", me) )
		title = G2B(title);

	tell(me, pnoun(2, me)+"ҿJ Bug ^DDGu"+title+NOR+"v\n");
	tell(me, HIY"пJ^ Bug ԲӤeC\n"NOR);
	me->edit( (: edit_bug_content, me, title :) );
}	

void edit_reply_content(object me, string number, string status, string content)
{
	BUG_D->reply_bug(me, number, status, content);
	
	tell(me, "^s "+number+"  Bug C\n");
	
	me->finish_input();
}

void confirm_input_reply(object me, string number, string status, string confirm)
{
	if( stringp(confirm) )
		confirm = lower_case(confirm);
		
	switch(confirm)
	{
		case "yes":
		case "y":
			tell(me, HIY"пJBzԲӤeC\n"NOR);
			me->edit( (: edit_reply_content, me, number, status :) );
			return; 
		default:
			tell(me, HIY"JBzԲӤeC\n"NOR);
			BUG_D->reply_bug(me, number, status);
			me->finish_input();
			break;
	}
}
	

void input_reply_status(object me, string number, string arg)
{
	string status;

	switch(arg)
	{
		case "1":	status = HIR"Bz"NOR;	break;
		case "2":	status = HIY"Bz"NOR;	break;
		case "3":	status = HIC"w״_"NOR;	break;
		case "4":	status = HIR"Lk״_"NOR;	break;
		case "5":	status = HIW"ݳBz"NOR;	break;
		case "6":	status = HIM"ݦA^"NOR;	break;
		default:	status = HIR"Bz"NOR;	break;
	}
			
	tell(me, "O_JBzԲӤeH(Yes/No):");
	input_to( (: confirm_input_reply, me, number, status :) );
}

private void command(object me, string arg)
{
	string number;

	if( !is_command() ) return;
	
	if( wizardp(me) )
	{
		if( !arg || !arg[0] )
			return me->more(query_temp("bug_msg", me) || pnoun(2, me)+"WS~^ơC\n");
		
		else if( find_player(arg) )
			return me->more(query_temp("bug_msg", find_player(arg)) || find_player(arg)->query_idname()+"WS~^ơC\n");
		
		else if( sscanf(arg, "-r %s", number) )
		{
			if( !BUG_D->bug_exists(number) )
				return tell(me, "èSs "+number+"  Bug sbC\n"NOR);
				
			tell(me, HIY"пJثeBzpsG\n[1]"HIR"Bz"NOR" [2]"HIY"Bz"NOR" [3]"HIC"w״_"NOR" [4]"HIR"Lk״_"NOR" [5]"HIW"ݳBz"NOR" [6]"HIM"ݦA^"NOR"\n:");
			input_to( (: input_reply_status, me, number :) );
			return;
		}
		else if( sscanf(arg, "-d %s", number) )
		{
			int reply;
	
			sscanf(number, "%s reply %d", number, reply);
			
			if( !BUG_D->bug_exists(number) )
				return tell(me, "èSs "+number+"  Bug sbC\n"NOR);

			if( reply > 0 )
			{
				BUG_D->remove_bug(me, number, reply);
				tell(me, "Rs "+number+"  Bug  "+reply+" g^C\n"NOR);
			}
			else
			{
				BUG_D->remove_bug(me, number);
				tell(me, "Rs "+number+"  Bug ҦơC\n"NOR);
			}

			return;
		}
	}
	
	if( !arg )
		return tell(me, help);
	
	else if( arg == "-l" )
		return me->more(BUG_D->list_bug(1));
		
	else if( arg == "-a" )
	{
		tell(me, HIW"wϥ"WHT"(Bug)^t\n"NOR HIG"^ Bug ɽиԭzoͮɶBaϮyЦaIBUFLOPtܪT\nԲӪƱNiHUŮvֳtѨM"+pnoun(2, me)+"J쪺 BugC\n"NOR);
		tell(me, HIY"пJ^ Bug DD(ȥDDADԲӤe)AΪ Enter JC\n:"NOR);
		input_to( (: input_bug_title, me :) );
		return;
	}
	else if( big_number_check(arg) )
	{
		if( !BUG_D->bug_exists(arg) )
			return tell(me, "èSs "+arg+"  Bug sbC\n"NOR);

		tell(me, BUG_D->query_bug(arg));
	}
	else return tell(me, help);
}