/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : decorate.c
 * Author : Clode@RevivalWorld
 * Date   : 2002-09-11
 * Note   : ؿvCOC
 * Update :
 *  o 2000-00-00
 *
 -----------------------------------------
 */

#include <ansi.h>
#include <daemon.h>
#include <feature.h>
#include <location.h>
#include <message.h>
#include <citydata.h>

inherit COMMAND;

string help = @HELP
decorate [short [-d] | long [-d] | sign r | function [\] | master [-d]]

decorate short			]wuW(жPaϤWҥi]w)
decorate short -d		RuW(ȾAΩaϤW)
decorate long			]wԭz(жPaϤWҥi]w)
decorate long -d		Rԭz(ȾAΩaϤW)
decorate sign 'r'		ؿvжAi]wγr
decorate function '\'	ؿvжAi]wж\૬A
decorate function		CXi]wжA
decorate function -d		ثeж\૬A
decorate master Dy  	iж]w۹Dns곡ҦbPy( 2 50,50)
decorate master -d		RжDns곡]w

HELP;

#define MAX_LONG_WIDTH		72
#define MAX_LONG_LINE		20
#define MAX_LONG_LINE_MAP	3
#define MAX_SHORT_WIDTH		24
#define MAX_SHORT_WIDTH_MAP	18

private varargs void input_room_short(object me, object env, string arg, int no_encode)
{
	array loc = query_temp("location", me);

	if( !arg || !arg[0] )
	{
		tell(me, "קC\n");
		return me->finish_input();
	}
	
	if( !no_encode && query("encode/gb", me) ) arg = G2B(arg);

	arg = ansi(arg);
	arg = remove_fringe_blanks(arg);
	arg = kill_repeat_ansi(arg+NOR);

	if( (env->is_maproom() && noansi_strlen(arg) > MAX_SHORT_WIDTH_MAP) || noansi_strlen(arg) > MAX_SHORT_WIDTH )
	{
		tell(me, "uWٳ̦hu "+(env->is_maproom()?MAX_SHORT_WIDTH_MAP:MAX_SHORT_WIDTH)+" ӦrC\n");
		return me->finish_input();
	}

	if( env->is_maproom() )
	{
		(MAP_D->query_map_system(loc))->set_coor_data(loc, "short", arg);
		msg("$MEק惡auW٬u"+arg+"vC\n", me, 0, 1);
		return;
	}
	else
	{
		set("short", arg, env);
		msg("$MEק惡auW٬u"+arg+"vC\n", me, 0, 1);

		if( !env->save() )
			error("decorate save room error.");
	}	
	me->finish_input();
}

private void input_room_long(object me, object env, string arg)
{
	array loc = query_temp("location", me);

	if( !arg || !arg[0] )
	{
		tell(me, "קC\n");
		return me->finish_input();
	}

	arg = multiwrap(arg, MAX_LONG_WIDTH);

	arg = ansi(arg);
	arg = kill_repeat_ansi(arg+NOR);

	//[&,->A][&'->B][&.->C][&!->I][&?->H]
	arg = replace_string(arg, "&,", "A");
	arg = replace_string(arg, "&'", "B");
	arg = replace_string(arg, "&.", "C");
	arg = replace_string(arg, "&!", "I");
	arg = replace_string(arg, "&?", "H");

	if( (env->is_maproom() && sizeof(explode(arg, "\n")) > MAX_LONG_LINE_MAP) || sizeof(explode(arg, "\n")) > MAX_LONG_LINE )
	{
		tell(me, "жԭz̦hu঳ "+(env->is_maproom()?MAX_LONG_LINE_MAP:MAX_LONG_LINE)+" C\n");
		return me->finish_input();
	}

	if( env->is_maproom() )
	{
		(MAP_D->query_map_system(loc))->set_coor_data(loc, "long", arg+"\n");
		msg("$MEק惡aԭz\nu\n"+arg+"\n"+repeat_string(" ", MAX_LONG_WIDTH)+"vC\n", me, 0, 1);
	}
	else
	{
		set("long", arg, env);
		msg("$MEק惡aԭz\nu\n"+arg+"\n"+repeat_string(" ", MAX_LONG_WIDTH)+"vC\n", me, 0, 1);

		if( !env->save() )
			error("decorate save room error.");
	}
}

private void do_command(object me, string arg)
{
	object env = environment(me);
	string option;
	array loc = query_temp("location", me);
	string owner = query("owner", env);

	if( !arg )
		return tell(me, "пJQnC(short, long, function, sign, master)C\n");

	if( !env )
		return tell(me, pnoun(2, me)+"Lkbo̰Cʧ@C\n");

	if( env->is_maproom() )
		owner = (MAP_D->query_map_system(loc))->query_coor_data(loc, "owner");

	if( !owner )
		return tell(me, "oжO"+pnoun(2, me)+"ALkCoжC\n");
	else if( belong_to_government(owner) )
	{
		if( !wizardp(me) && !CITY_D->is_mayor_or_officer(env->query_city(), me) )
			return tell(me, pnoun(2, me)+"OΩxALkCoжC\n");
	}
	else if( belong_to_enterprise(owner) )
	{
		if( owner[11..] != query("enterprise", me) )
			return tell(me, pnoun(2, me)+"O"+ENTERPRISE_D->query_enterprise_color_id(query("enterprise", me))+"~ΪALkCoжC\n");
	}
	else if( owner != me->query_id(1) )
		return tell(me, "oжO"+pnoun(2, me)+"ALkCoжC\n");

	sscanf(arg, "%s %s", arg, option);

	switch(arg)
	{
	case "short":
		if( option == "-d" )
		{
			if( env->is_maproom() )
				(MAP_D->query_map_system(loc))->delete_coor_data(loc, "short");
			else
				return tell(me, "LkRжuW١C\n");

			return tell(me, "RuW٧C\n");
		}
		else if( option )
			return input_room_short(me, env, option, 1);

		tell(me, HIC"\nпJжuW١G"NOR);
		input_to( (: input_room_short, me, env :) );
		return;

	case "long":
		if( option == "-d" )
		{
			if( env->is_maproom() )
				(MAP_D->query_map_system(loc))->delete_coor_data(loc, "long");
			else
				return tell(me, "LkRжԭzC\n");

			return tell(me, "RԭzC\n");
		}
		tell(me, HIC"\nпJжԭzG\n"HIR"C̦h "+MAX_LONG_WIDTH+" rA̦h "+MAX_LONG_LINE+" \n"HIG"Ϊ`ŸֳtഫG[&,->A][&'->B][&.->C][&!->I][&?->H]\n"NOR);
		me->edit( (: input_room_long, me, env :) );
		return;

	case "function":
		{
			mapping action_info;
			if( env->is_maproom() )
				return tell(me, "o̵Lko˪Cʧ@C\n");

			action_info = env->query_action_info();

			if( !option )
			{
				string msg = "oɫؿv]mж\঳HU "+sizeof(action_info)+" ءG\n";

				msg += WHT"wwwwwwwwwwwwwwwwwwwwwwwwwwwwwww\n"NOR;
				msg +=    " \         W         \\n";
				msg += WHT"wwwwwwwwwwwwwwwwwwwwwwwwwwwwwww\n"NOR;
				foreach( string short, mapping info in action_info )
				msg += sprintf(" %-12s %-12s %s\n", HIY+capitalize(short)+NOR, info["short"], YEL+implode(keys(info["action"]), " ")+NOR);

				msg += WHT"wwwwwwwwwwwwwwwwwwwwwwwwwwwwwww\nпJ decorate function '\'C\n\n"NOR;

				return tell(me, msg);
			}

			option = lower_case(option);

			if( option == "-d" )
			{
				if( env->remove_room_function() )
				{
					env->remove_master();
					env->remove_slave();
					return tell(me, "ж\]wAPɧRs]wC\n");
				}
				else
					return tell(me, "ѡC\n");
			}
			
			if( !wizardp(me) && strsrch(query("long", env), "o") != -1 )
				return tell(me, "oж٨SJӸCLAӹLõLk]wж\C\n");

			if( option == "scenery" && env->query_floor() != 100 && env->query_floor() != 120 && env->query_floor() != 140 && env->query_floor() != 160 )
				return tell(me, "[xub 100F / 120F / 140F / 160F ӼhiH]mC\n");
			
			if( query("function", env) == option )
				return tell(me, "жwg]w\C\n");
			
			if( !env->set_room_function(option) )	
				return tell(me, "oɫؿvSoжC\n");

			env->remove_master();
			env->remove_slave();
			msg("$MENoж]m"+action_info[option]["short"]+"γ~C\n",me,0,1);

			break;
		}
	case "sign":
		{
			if( env->is_maproom() )
				return tell(me, pnoun(2, me)+"LkקaϤWϧΡC\n");
	
			if( !option )
				return tell(me, "BγWϧάOu"+(MAP_D->query_map_system(env->query_location()))->query_coor_icon(env->query_location())+NOR"vC\n");
			if( option == "-d" )
			{
				string origin_sign;
	
				if( env->is_maproom() )
					origin_sign = (MAP_D->query_map_system(loc))->query_coor_icon(loc);
				else
					origin_sign = (MAP_D->query_map_system(env->query_location()))->query_coor_icon(env->query_location());
	
				msg("$MEWFo̪γN쥻u"+origin_sign+"vr~FC\n", me, 0, 1);
				(MAP_D->query_map_system(env->query_location()))->set_coor_icon(env->query_location(), "  ");
				break; 
			}
	
	
			if( noansi_strlen(option) > 2 )
				return tell(me, "۵P@өж̦h 2 ӦrC\n");
	
			(MAP_D->query_map_system(env->query_location()))->set_coor_icon(env->query_location(), sprintf("%2s", kill_repeat_ansi(option+NOR)));
			msg("$MEۤ@oAWFo̪γjjagFӡu"+option+NOR"vrC\n",me, 0, 1);

			break;
		}
	case "master":
		{
			int x, y, section;
			array envloc = env->query_location();
			array newloc;
			string room_type, env_basename, master_basename;
			object master = env->query_master();
			string functionname;
			mapping products;
		
			if( env->is_maproom() )
				return tell(me, "o̵Lko˪Cʧ@C\n");

			if( !option )	
				return tell(me, "пJDsжҦbPy(ҦpĤGìPG2 53,49)C\n",me, 0, 1);

			functionname = query("function", env);
			
			if( !functionname )
				return tell(me, "ж]wж\णisʧ@C\n");

			if( !mapp(env->query_action_info(functionname)) || !env->query_action_info(functionname)["master"] )
				return tell(me, "إ\жLkisʧ@C\n");

			if( option == "-d" )
			{
				if( master == env )
					env->remove_slave();

				env->remove_master();
				env->save();
				return tell(me, "RжDs"+query("short", master)+"]wC\n");
			}

			if( sscanf(option, "%d %d,%d", section, x, y) != 3 )
				return tell(me, "пJDsжҦbPy(ҦpĤGìPG2 53,49)C\n",me, 0, 1);

			if( sizeof(products = query("products", env)) )
				tell(me, HIY"`NGsꤧoөж쥻wsƱN|Q\(ҦƥHsꤤ߬)\nѰs᥻жlwsƫKiHAܥXӡC\n"NOR);
				
			env->remove_master();
			env_basename = base_name(env);

			room_type = ESTATE_D->query_loc_estate(envloc)["type"];

			if( !CITY_D->city_exist(envloc[CITY], section-1) )
				return tell(me, CITY_D->query_city_idname(envloc[CITY])+"S "+section+" ìPC\n");

			master_basename = CITY_ROOM_MODULE(envloc[CITY], (section-1), (x-1), (y-1), room_type);
			newloc = arrange_city_location(x-1, y-1, envloc[CITY], section-1);
			
			if( master_basename == env_basename )
				return tell(me, "DsOۤvC\n");

			if( sizeof(query("slave", env)) )
				return tell(me, "жOsꤤߡAwgQLsALkAsܨLC\n");

			if( !file_exists(master_basename) )
			{
				tell(find_player("sinji"), master_basename);
				return tell(me, "y"+loc_short(newloc)+"BèSؿvC\n");
			}
			master = load_object(master_basename);

			if( query("owner", master) == "GOVERNMENT/"+envloc[CITY] )
			{
				if( !CITY_D->is_mayor_or_officer(envloc[CITY], me) )
					return tell(me, pnoun(2, me)+"OΩxALkCoжC\n");
			}
			else if( query("owner", master) != me->query_id(1) )
				return tell(me, "y"+loc_short(newloc)+""+master->query_room_name()+"äOݩ"+pnoun(2, me)+"C\n");

			if( master->query_master() != master )
				return tell(me, "y"+loc_short(newloc)+""+master->query_room_name()+"wgۤvҹDsALkQ]wDsC\n");

			if( query("function", env) != query("function", master) )
				return tell(me, "y"+loc_short(newloc)+""+master->query_room_name()+"Pж\äۦPALk]wsC\n");

			if( sizeof(master->query_slave()) > 500 )
				return tell(me, "sжƤoWL 500C\n");

			if( !env->set_master(master) )
				return tell(me, "Lk]w䬰DsC\n");

			// HQΨӳs꤬ۥ洫ȧQ, QΨst, X洫ɥspʶRɦȧQ, ]ΥHU{ץ
			env->query_module_file()->calculate_master_data(master);

			msg("$ME]w"+master->query_room_name()+"жDns곡C\n", me, 0, 1);
			break;
		}
	default:
		return tell(me, "пJQnC(short, long, function, sign, master)C\n");
	}

	if( env->save() )
		tell(me, "CC\n");
	else
		tell(me, "CѡC\n");
}
