/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : land.c
 * Author : Clode@RevivalWorld
 * Date   : 2006-03-08
 * Note   : land O
 * Update :
 *  o 2000-00-00
 *
 -----------------------------------------
 */

#include <ansi.h>
#include <feature.h>
#include <daemon.h>
#include <map.h>
#include <location.h>

inherit COMMAND;

string help = @HELP
    gaاlǡC

land			- dߥثewglǪga
land absorb		- lǤga(ݭnS~)
land release 'Ʀr'	- NgaئC N ӧlgaثeҦbga

HELP;

private void do_command(object me, string arg)
{
	int i;

	if( !arg )
	{
		string list = "";
		array landdata = query("landdata", me);
		
		if( arrayp(landdata) && sizeof(landdata) )
		{
			list += HIY"ga"NOR YEL""NOR"\n";
			foreach(array elem in landdata)
			{
				i++;
				switch(elem[0])
				{
					case FARM: 
						list += sprintf("%-3d%-20s "NOR GRN"ga "HIG"%s"NOR GRN"/%d\n"NOR, i, HIG"A"NOR, repeat_string("*", elem[1]), elem[2]);
						break;
					case PASTURE: 
						list += sprintf("%-3d%-20s "NOR YEL"ga "HIY"%s"NOR YEL"/%d\n"NOR, i, NOR YEL""NOR, repeat_string("*", elem[1]), elem[2]);
						break;
					case FISHFARM: 
						list += sprintf("%-3d%-20s "NOR BLU"ga "HIB"%s"NOR BLU"/%d\n"NOR, i, HIB"i޳"NOR, repeat_string("*", elem[1]), elem[2]);
						break;
				}
			}
			return tell(me, list+"\n");
		}
		else
			return tell(me, "ثeSgalǺءC\n");
	}
	else if( arg == "absorb" )
	{
		int type;
		int growth_level;
		int maintain_time;
		
		object media;
		object env = environment(me);
		array loc = query_temp("location", me);
		array landdata = query("landdata", me) || allocate(0);
		
		if( !env->is_maproom() || !arrayp(loc) || !CITY_D->city_exist(loc[CITY], loc[NUM]) )
			return tell(me, "LklǳogaءC\n");
		
		if( CITY_D->query_coor_data(loc, "owner") != me->query_id(1) )
			return tell(me, "ogaäO"+pnoun(2, me)+"C\n");
			
		foreach(object ob in all_inventory(me))
		{
			if( query("land_absorb", ob) )	
			{
				media = ob;
				break;
			}
		}
		
		if( !objectp(media) )
			return tell(me, pnoun(2, me)+"WʥFlǤgaتC~C\n");
		
		type = CITY_D->query_coor_data(loc, TYPE);
		growth_level = CITY_D->query_coor_data(loc, "growth_level");
		maintain_time = CITY_D->query_coor_data(loc, "maintain_time");
	
		if( type != FARM && type != FISHFARM && type != PASTURE )
			return tell(me, "LklǳoؤgaءC\n");
	
		if( maintain_time < 1 )
			return tell(me, "ogaSإiHlC\n");

		msg("$MEN$YOUmbgaAu$YOUoX벴"HIW"ե"NOR"Nogaاlǰ_ӡC\n", me, media, 1);
		msg("HۥեvhA$YOU]ۮFC\n", me, media, 1);
		destruct(media, 1);

		CITY_D->delete_coor_data(loc, "growth_level");
		CITY_D->delete_coor_data(loc, "maintain_time");
		CITY_D->delete_coor_data(loc, "growth");
		CITY_D->delete_coor_data(loc, "status");
		TOP_D->delete_top("maintain", save_variable(loc));

		landdata += ({ ({ type, growth_level, maintain_time }) });
		set("landdata", landdata, me);
		me->save();
	}
	else if( sscanf(arg, "release %d", i) == 1 )
	{
		object env = environment(me);
		array landdata = query("landdata", me);
		array loc = query_temp("location", me);
		array elem;
		
		if( !env->is_maproom() || !arrayp(loc) || !CITY_D->city_exist(loc[CITY], loc[NUM]) )
			return tell(me, "LkNgaogaWC\n");

		if( CITY_D->query_coor_data(loc, "owner") != me->query_id(1) )
			return tell(me, "ogaäO"+pnoun(2, me)+"C\n");
			
		if( !arrayp(landdata) )
			return tell(me, "ثeS󪺤gaءC\n");

		if( i < 1 || i > sizeof(landdata) )
			return tell(me, "пJTƦrC\n");

		elem = landdata[i-1];
		
		if( CITY_D->query_coor_data(loc, TYPE) != elem[0] )
			return tell(me, "LkNogaogaWC\n");
			
		if( CITY_D->query_coor_data(loc, "maintain_time") )
			return tell(me, "ogawg{sgaءALkANgaogaWC\n");

		CITY_D->set_coor_data(loc, "growth_level", elem[1]);
		CITY_D->set_coor_data(loc, "maintain_time", elem[2]);
		GROWTH_D->set_status(loc);
		
		msg("$MENjqgaogaWAugaWx_@}"HIW"ծ~"NOR"C\n", me, 0, 1);
		TOP_D->update_top("maintain", save_variable(loc), elem[1], me->query_idname(), elem[0]);

		landdata = landdata[0..i-2] + landdata[i..<1];
		
		if( !sizeof(landdata) )
			delete("landdata", me);
		else
			set("landdata", landdata, me);
		
		me->save();
	}
	else return tell(me, "пJTOѼ(help land)C\n");
}
