/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : open.c
 * Author : Clode@RevivalWorld
 * Date   : 2001-08-24
 * Note   : ؿv}iOAnOC
 * Update :
 *  o 2000-00-00
 *
 -----------------------------------------
 */

#include <ansi.h>
#include <daemon.h>
#include <feature.h>
#include <location.h>
#include <map.h>
#include <message.h>
#include <roommodule.h>

inherit COMMAND;

string help = @HELP
    ANզX@ӱKXaϮɡAKiHϥΦOӶ}iһݭnؿv
OϥήɥnbؿvWAL׬OξiHCثe}񪺫ؿv
GpөBv... C

    bؿvɫhiQ open up OөW[\ӼhAC[\@hKihX
@жAPɫؿvUaӪHPӾ]UAñaʫcaPOOC

    b[\ӼhiHQΥHUOӶ}qӼhqDAC}P@ӳqDݪ
O 10,000 
      
    open north		- }P_䪺qD
    open south		- }Pn䪺qD
    open west		- }P䪺qD
    open east		- }PF䪺qD
      
۹}iOA]ҿתOC

O: blist, close
HELP;

#define WALL_TABLE	0
#define ROOM_TABLE	1

#define OPEN_DOOR_COST	10000

#define CORRESPONDING_DIRECTION	([ "north":"south", "south":"north", "west":"east", "east":"west" ])

void confirm_build_up(object me, object env, string owner, string nfile, string ofile, string bfile, int newfloor, string cost, string yn)
{
	string city;
	object room, broom;
	string moneyunit;

	if( lower_case(yn) != "y" )
	{
		tell(me, pnoun(2, me)+"󩹤W[\ӼhC\n");
		me->finish_input();
		return;
	}

	city = env->query_city();
	moneyunit = MONEY_D->city_to_money_unit(city);

	if( belong_to_enterprise(owner) )
	{
		moneyunit = MONEY_D->query_default_money_unit();
		
		if( !ENTERPRISE_D->change_assets(query("enterprise", me), "-"+cost) )
		{
			tell(me, "~wg[\ӼhFC\n");
			return me->finish_input();
		}
	}
	else if( !me->spend_money(moneyunit, cost) )
	{
		tell(me, pnoun(2,me)+"W $"+moneyunit+" FII\n");
		return me->finish_input();
	}

	room = load_object(nfile);
	broom = load_object(bfile);
	
	addn("floor", 1, broom);
	broom->save();
	
	set("exits/down", ofile, room);
	set("firstfloor", bfile, room);
	set("owner", owner, room);
	set("short", copy(query("short", broom)), room);
	room->save();

	set("exits/up", nfile, env);
	env->save();
	
	if( !(newfloor%5) )	
		CHANNEL_D->channel_broadcast("city", me->query_idname()+"O "HIY"$"+moneyunit+" "+NUMBER_D->number_symbol(cost)+NOR" N"+query("short", broom)+"W[\ܲ "HIW+newfloor+NOR" ӡC", me);
	
	if( !(newfloor%20) )
		CHANNEL_D->channel_broadcast("news", me->query_idname()+"b"+CITY_D->query_city_name(city)+""+query("short", broom)+"ؿv} "HIW+newfloor+NOR" ӡAa "HIY+(newfloor/20)+NOR" ŦaСC");

	if( newfloor == 160 )
		me->add_title( HIR""NOR RED"Q"NOR HIR""NOR RED"J"NOR );
	else if( newfloor == 120 )
		me->add_title( HIR"ؿv"NOR RED"QD"NOR );
	else if( newfloor == 100 )
		me->add_title( HIR"u"NOR RED"ؿvv"NOR );
	else if( newfloor == 50 )
		me->add_title( HIR"ؿv"NOR RED"sq"NOR );
		
	tell(me, pnoun(2, me)+"O "HIY"$"+moneyunit+" "+NUMBER_D->number_symbol(cost)+NOR" N"+query("short", broom)+"W[\ܲ "+newfloor+" ӡC\n");

	if( !wizardp(me) )
		TOP_D->update_top("building", base_name(broom), newfloor, owner, broom->query_room_name(), city);

	me->finish_input();
}

void open_building(object me, string arg)
{
	int num;
	string owner, city, enterprise, cost, moneyunit;
	mapping table;
	array loc = query_temp("location",me);
	array building_info;

	if( !arrayp(loc) || !environment(me)->is_maproom() || !CITY_D->is_city_location(loc) )
		return tell(me, pnoun(2, me)+"baϤW}iؿvC\n");
		
	owner = CITY_D->query_coor_data(loc, "owner");
	
	city = loc[CITY];
	num = loc[NUM];

	moneyunit = MONEY_D->city_to_money_unit(city);
	
	if( !owner )
		return tell(me, "ogaݩHA"+pnoun(2, me)+"Lkb}iؿvC\n");

	arg = lower_case(arg);

	if( !BUILDING_D->has_building(arg) )
		return tell(me, "S "+arg+" oثؿvAd߫ؿvCпJ blistC\n");
	
	building_info = BUILDING_D->query_building(arg);

	if( building_info[ROOMMODULE_TESTING] && !wizardp(me) )
		return tell(me, "ؿvbʳդA|}سyC\n");

	// Fga
	if( belong_to_government(owner) )
	{
		if( !wizardp(me) )
		{
			if( !CITY_D->is_mayor_or_officer(loc[CITY], me) )
				return tell(me, pnoun(2, me)+"OoyΩxALkϥάFgaسyؿvC\n");
		
			if( !(building_info[ROOMMODULE_BUILDINGTYPE] & GOVERNMENT) )
				return tell(me, "FgaWuسyFؿvC\n");
		}
	}
	// ~ga
	else if( belong_to_enterprise(owner) )
	{
		enterprise = query("enterprise", me);
		moneyunit = MONEY_D->query_default_money_unit();

		if( !ENTERPRISE_D->is_member(enterprise, me->query_id(1)) )
			return tell(me, pnoun(2, me)+"Ooӥ~ΪALkϥΥ~gaسyؿvC\n");
		
		if( enterprise != owner[11..] )
			return tell(me, "ogaäݩ"+ENTERPRISE_D->query_enterprise_color_id(enterprise)+"~ΡC\n");
			
		if( !(building_info[ROOMMODULE_BUILDINGTYPE] & ENTERPRISE) )
			return tell(me, "~gaWuسy~ؿvC\n");
	}
	// ӤHga
	else if( belong_to_individual(owner) )
	{
		if( owner != me->query_id(1) )
			return tell(me, "ogaOݩ "+owner+" AäO"+pnoun(2, me)+"gaC\n");
		
		if( !(building_info[ROOMMODULE_BUILDINGTYPE] & INDIVIDUAL) )
			return tell(me, "ӤHgaWuسyӤHؿvC\n");
	}
	
	// سy
	if( arg == "fence" )
	{
		int land_type = CITY_D->query_coor_data(loc, TYPE);
		string estate_type = ESTATE_D->query_loc_estate(loc)["type"];
		
		if( land_type != WALL && land_type != DOOR )
			return tell(me, pnoun(2, me)+"bzΪWӱҰʳ\C\n");

		if( estate_type == "fence" )
			return tell(me, "o̤wgOFC\n");

		if( estate_type != "land" )
			return tell(me, "o̤Ұʳ\C\n");			
		
		if( CITY_D->query_coor_data(loc, TYPE) == WALL )
			CITY_D->set_coor_data(loc, FLAGS, NO_MOVE);

		table = allocate_mapping(0);
		table["type"] = "fence";
		table["regtime"] = time();
		table["walltable"] = ({ save_variable(loc) });
		table["roomtable"] = allocate(0);
		
		CITY_D->set_coor_icon(loc, WHT+remove_ansi(CITY_D->query_coor_icon(loc))+NOR);

		ESTATE_D->set_estate(owner, table, "fence", city, num);
		
		msg("$MEbaҰʤF\C\n", me, 0, 1);
		CHANNEL_D->channel_broadcast("city", me->query_idname()+"b"+loc_short(loc)+NOR"سyFu"HIM""NOR"v", me);
		return;
	}
	
	if( building_info[ROOMMODULE_MAXLIMIT] > 0 && ESTATE_D->query_owner_amount(owner, arg) >= building_info[ROOMMODULE_MAXLIMIT] )
		return tell(me, "ثؿvCӬF/~/aoسyWL "+building_info[ROOMMODULE_MAXLIMIT]+" ɡC\n");
	
	if( CITY_D->query_city_info(city, "age") < building_info[ROOMMODULE_AGE] )
		return tell(me, "ثeoyɥNu"+CITY_D->query_age_name(city)+"vALkسyؿvC\n");

	// WLCyؿvƶq
	if( building_info[ROOMMODULE_MAXBUILDINGLIMIT] && ESTATE_D->query_city_amount(loc[CITY], loc[NUM], arg) >= building_info[ROOMMODULE_MAXBUILDINGLIMIT] )
		return tell(me, "oy"+building_info[ROOMMODULE_SHORT]+"ؿvƶqwgF "+building_info[ROOMMODULE_MAXBUILDINGLIMIT]+" ɪALkAW[FC\n");


	// Wˬd
	if( !(CITY_D->query_coor_data(loc, "region") & building_info[ROOMMODULE_REGION]) )
		return tell(me, building_info[ROOMMODULE_SHORT]+"سybؤgaWϤWC\n");

	// }iaIˬd
	if( CITY_D->query_coor_data(loc, TYPE) != DOOR )
		return tell(me, pnoun(2, me)+"bjfӶiؿv}iC\n");

	// ޿
	if( !mapp(table = BUILDING_D->analyze_building_logic(loc)) )
		return tell(me, "ɫؿvسycDALk}iAбN~sسyC\n");

	foreach( string coor, mixed data in CITY_D->query_coor_range(loc, ROOM, 1) )
		if( data )
			return tell(me, pnoun(2, me)+"oɫؿv~୫s}iC\n");

	if( sizeof(table["roomtable"]) < building_info[ROOMMODULE_ROOMLIMIT] )
		return tell(me, building_info[ROOMMODULE_SHORT]+"ֻ̤ݭn"+CHINESE_D->chinese_number(building_info[ROOMMODULE_ROOMLIMIT])+"жAoɫؿvu"+CHINESE_D->chinese_number(sizeof(table["roomtable"]))+"жC\n");

	if( !building_info[ROOMMODULE_OPENCOST] )
		return tell(me, "Lk}ioثؿvC\n");

	// p}iO
	cost = count(building_info[ROOMMODULE_OPENCOST], "*", sizeof(table["roomtable"]));

	if( belong_to_government(owner) )
	{
		CHANNEL_D->channel_broadcast("city", me->query_idname()+"ʥΥ겣 "+HIY+money(moneyunit, cost)+NOR" b"+CITY_D->query_city_idname(city, num)+""+CITY_D->position(loc[X], loc[Y])+"سyF@"+building_info[ROOMMODULE_SHORT]+"C\n", me);
		CITY_D->change_assets(city, "-"+cost);
	}
	else if( belong_to_enterprise(owner) )
	{
		if( ENTERPRISE_D->change_assets(enterprise, "-"+cost) )
			CHANNEL_D->channel_broadcast("news", "~Ρu"+ENTERPRISE_D->query_enterprise_color_id(enterprise)+"vO~겣 "+HIY+money(moneyunit, cost)+NOR" b"+CITY_D->query_city_idname(city, num)+"سyF@"+building_info[ROOMMODULE_SHORT]+"C\n");		
		else if( me->spend_money(moneyunit, cost) )
		{
			ENTERPRISE_D->change_invest(enterprise, me->query_id(1), cost);
			CHANNEL_D->channel_broadcast("news", "~Ρu"+ENTERPRISE_D->query_enterprise_color_id(enterprise)+"vOӤH "+HIY+money(moneyunit, cost)+NOR" b"+CITY_D->query_city_idname(city, num)+"سyF@"+building_info[ROOMMODULE_SHORT]+"C\n");
			tell(me, "~Ϊ{H}iؿvFA]O"+pnoun(2, me)+"pH "+money(moneyunit, cost)+" i}iC\n");
		}
		else
			return tell(me, "~겣"+pnoun(2, me)+"pH{wgHI "+HIY+money(moneyunit, cost)+NOR+"C\n");
	}
	else if( me->spend_money(moneyunit , cost) )
		CHANNEL_D->channel_broadcast("city", me->query_idname()+"O "+HIY+money(moneyunit, cost)+NOR" b"+CITY_D->query_city_idname(city, num)+""+CITY_D->position(loc[X], loc[Y])+"سyF@"+building_info[ROOMMODULE_SHORT]+"C\n", me);
	else
		return tell(me, "}i"+building_info[ROOMMODULE_SHORT]+"ݭn򥻸CP}iO"+HIY+money(moneyunit, cost)+NOR"C\n");


	BUILDING_D->materialize_city_building(me, owner, table, city, num, arg);
	
}


void open_up(object me)
{
	int x, y, z, newfloor;
	object env = environment(me);
	string owner, fhead, file = base_name(env), nfile;
	string type, bfile, cost, money_unit = MONEY_D->city_to_money_unit(env->query_city());

	owner = query("owner", env);

	if( env->is_maproom() )
		return tell(me, pnoun(2, me)+"bؿvW[\C\n");
	
	if( belong_to_enterprise(owner) )
	{
		if( query("enterprise", me) != owner[11..] )
			return tell(me, pnoun(2, me)+"O~ΪC\n");
	}
	else if( owner != me->query_id(1) )
		return tell(me, pnoun(2, me)+"Ooɫؿv̡֦C\n");

	if( query("exits/up", env) )
		return tell(me, "W@hӼhwg[\C\n");

	if( sscanf(file, "%s/room/%d_%d_%d_%s", fhead, x, y, z, type) == 5 || sscanf(file, "%s/room/%d_%d_%s", fhead, x, y, type) == 4 )
	{
		nfile = fhead+"/room/"+x+"_"+y+"_"+(z+1)+"_"+type;
		bfile = fhead+"/room/"+x+"_"+y+"_"+type;
		
		newfloor = z+2;
		
		if( newfloor > BUILDING_D->query_building_table()[type][ROOMMODULE_MAXFLOOR] )
			return tell(me, "ثؿv̦hu[\ܦӡC\n");

		if( newfloor <= 100 )
		{	
			if( me->query_skill_level("architectonic") < newfloor )
				return tell(me, pnoun(2, me)+"ؿv޳NHAW[\ӼhC\n");
		}
		else
		{
			if( me->query_skill_level("architectonic") < 100 )
				return tell(me, pnoun(2, me)+"Nؿv޳Nɨ̰šC\n");
			
			if( me->query_skill_level("architectonic-adv")+100 < newfloor )
				return tell(me, pnoun(2, me)+"ؿvޯ൥ŤHAW[\ӼhC\n");
		}
		
		cost = BUILDING_D->query_floor_value(newfloor);
			
		tell(me, "[\ "+newfloor+" Ӽhݭn "HIY"$"+money_unit+" "+NUMBER_D->number_symbol(cost)+HIG"\nO_Tw[\H(Y/N)"NOR);
		input_to((: confirm_build_up, me, env, owner, nfile, file, bfile, newfloor, cost:));
		
		return;
	}
	
	tell(me, "oɫؿvLkW[\ӼhC\n");
}

void open_door(object me, string arg)
{
	int x, y, z;
	object nextroom, env = environment(me);
	string type, fhead, file = base_name(env);
	string owner, money_unit = MONEY_D->city_to_money_unit(env->query_city());

	owner = query("owner", env);

	if( env->is_maproom() )
		return tell(me, pnoun(2, me)+"bؿvW[\C\n");
	
	if( belong_to_enterprise(owner) )
	{
		if( query("enterprise", me) != owner[11..] )
			return tell(me, pnoun(2, me)+"O~ΪC\n");
	}
	else if( owner != me->query_id(1) )
		return tell(me, pnoun(2, me)+"Ooɫؿv̡֦C\n");

	if( query("exits/"+arg, env) )
		return tell(me, "ӤVqDwg}C\n");

	if( sscanf(file, "%s/room/%d_%d_%d_%s", fhead, x, y, z, type) != 5 )
		return tell(me, pnoun(2, me)+"ub 2 ӥHWж}PqDC\n");
		
	if( arg == "south" ) y++;
	else if( arg == "north" ) y--;
	else if( arg == "west" ) x--;
	else if( arg == "east" ) x++;
	
	if( !objectp(nextroom = find_object(fhead+"/room/"+x+"_"+y+"_"+z+"_"+type)) )
		return tell(me, "ӤV᭱èSжC\n");

	if( belong_to_enterprise(owner) )
	{
		if( !ENTERPRISE_D->change_assets(query("enterprise", me), "-"+OPEN_DOOR_COST) )
			return tell(me, "~wg}PqDFC\n");
	}
	else if( !me->spend_money(money_unit, OPEN_DOOR_COST) )
		return tell(me, pnoun(2,me)+"W $"+money_unit+" FII\n");

	set("exits/"+arg, base_name(nextroom), env);
	set("exits/"+CORRESPONDING_DIRECTION[arg], file, nextroom);
		
	msg("$MEO $"+money_unit+" 10,000 Ns"+query("short", env)+env->query_coor_short()+"P"+query("short", nextroom)+nextroom->query_coor_short()+"qD}C\n", me, 0, 1);
	
	env->save();
	nextroom->save();
}

private void do_command(object me, string arg)
{
	if( !arg || !arg[0] ) 
		return tell(me, "п"+pnoun(2, me)+"QnϥΪؿvAd߫ؿvCJ blistC\n");

	arg = lower_case(arg);
	
	if( arg == "up" )
		open_up(me);
	else if( !undefinedp(CORRESPONDING_DIRECTION[arg]) )
		open_door(me, arg);
	else 
		open_building(me, arg);
}
