/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : edemote.c
 * Author : Clode@RevivalWorld
 * Date   : 2002-9-13
 * Note   : O
 * Update :
 *  o 2000-00-00  
 *
 -----------------------------------------
 */

#include <ansi.h>
#include <emotion.h>
#include <feature.h>
#include <daemon.h>
#include <message.h>

inherit COMMAND;

string help = @HELP
Os边

edemote 'O'	- sO
edemote -d 'O'	- RO

HELP;

private int valid_emote_name(string emotion)
{
	return strsrch(emotion, " ") == -1;
}

private void choose_option(object me, string emotion, mapping modifying_emotion, string arg);
private void setup_emotion(object me, string emotion, mapping modifying_info, int option, string contiune_arg, string arg);

private string replace_keys(string description)
{
	if( !description ) return "|]w";
	
	description = replace_string(description, "$ME", 	HIC"A"NOR);
	description = replace_string(description, "$YOU", 	HIG"YH"NOR);
	description = replace_string(description, "$T", 	HIM"ƪ"NOR);
	
	return description;
}
private string emotion_detail_description(string emotion, mixed info)
{
	string msg = "ww  "HIY+emotion+NOR+" ԲӱԭzpUG"+repeat_string("w", 13-(strlen(emotion)/2))+"\n";
	
	msg += NOR WHT"1.LHL[r    G"NOR+replace_keys(info[NONE_ALL])+"\n";
	msg += NOR WHT"2.LH[r    G"NOR+replace_keys(info[NONE_ALL_ARG])+"\n";
	msg += NOR WHT"3.HۤvL[rG"NOR+replace_keys(info[ME_ALL])+"\n";
	msg += NOR WHT"4.Hۤv[rG"NOR+replace_keys(info[ME_ALL_ARG])+"\n";
	msg += NOR WHT"5.HYHL[rG"NOR+replace_keys(info[YOU_ALL])+"\n";
	msg += NOR WHT"6.HYH[rG"NOR+replace_keys(info[YOU_ALL_ARG])+"\n";
	msg += NOR WHT"7.            G"NOR+(info[NOTE] || "|]w")+"\n";
	msg += NOR WHT"8.ϥΦ            G"NOR+info[USE]+" \n";
	msg += "wwwwwwwwwwwwwwwwwwwwwwwwwww\n";
	return msg;
}

private void confirm_delete_emotion(object me, string emotion, string arg)
{
	if( lower_case(arg) == "y" )
	{
		if( EMOTE_D->delete_emotion(emotion) )
			tell(me, "RO "+emotion+" \C\n");
		else
			tell(me, "RѡAгqŮvBzC\n");
		
		COMMAND_D->do_reset();
		return me->finish_input();
	}
	else
	{
		tell(me, "RC\n");
		return me->finish_input();
	}
}

private void setup_emotion(object me, string emotion, mapping modifying_info, int option, string multi_line_arg, string arg)
{
	if( !arg || !arg[0] )
	{
		multi_line_arg += "\n";
		tell(me, ">");
		input_to( (: setup_emotion, me, emotion, modifying_info, option, multi_line_arg :) );
	}
	
	switch(arg)
	{
		case "cancel":
			tell(me, "JԭzC\n"+emotion_detail_description(emotion, modifying_info)+"пJ]w(]w save, ]w exit)G\n>");
			input_to( (: choose_option, me, emotion, modifying_info :) );
			break;
		
		case ".":
			// ̨ΤƱԭz
			multi_line_arg = kill_repeat_ansi(remove_fringe_blanks(multi_line_arg) + NOR);
			modifying_info[option-1] = multi_line_arg;
			
			tell(me, "]wC\n"+emotion_detail_description(emotion, modifying_info)+"пJ]w(]w save, ]w exit)G\n>");
			input_to( (: choose_option, me, emotion, modifying_info :) );
			break;
		default:
			multi_line_arg += arg+"\n";
			tell(me, ">");
			input_to( (: setup_emotion, me, emotion, modifying_info, option, multi_line_arg :) );
	}
}
	
private void choose_option(object me, string emotion, mapping modifying_info, string arg)
{
	int option;
	
	switch(arg)
	{
		case "save":
			if( sizeof(modifying_info) != 8 )
			{
				tell(me, "]wҦԭz~xs]wC\nпJ]w(]w save, ]w exit)G\n>");
				input_to( (: choose_option, me, emotion, modifying_info :) );
				return;
			}
			else
			{
				array info = allocate(0);
				
				for(int i=0;i<8;i++)
					info += ({ modifying_info[i] });
					
				if( EMOTE_D->set_emotion(emotion, info) )
				{
					tell(me, "O "+emotion+" ]wxs\C\n");
					COMMAND_D->do_reset();
				}
				else
					tell(me, "O "+emotion+" ]wxsѡC\n");
					
				return me->finish_input();
			}
			break;
			
		case "exit":
			tell(me, " "+emotion+" O]wC\n");
			return me->finish_input();
			
		default:break;
	}
	
	option = to_int(arg);
	
	if( option > 8 || option < 1 )
	{
		tell(me, "SoӿﶵC\nпJ]w(]w save, ]w exit)G\n>");
		input_to( (: choose_option, me, emotion, modifying_info :) );
	}
	else if( option == USE+1 ) 
	{
		tell(me, "oӿﶵLkϥΤʳ]wC\nпJ]w(]w save, ]w exit)G\n>");
		input_to( (: choose_option, me, emotion, modifying_info :) );
	}
	else
	{
		tell(me, "\n ENTER iJhAJ '.' AJ 'cancel' C\nпJзǮ榡ԭz "HIC"$ME(Nۤv) "HIG"$YOU(NH) "HIY"$T(N[r)"NOR"G\n>");
		input_to( (: setup_emotion, me, emotion, modifying_info, option, "" :) );
	}
}
	
private void command(object me, string arg)
{
	array info;
	mapping modifying_info = allocate_mapping(8);
	
	if( !is_command() ) return;

	if( !arg ) return tell(me, pnoun(2, me)+"QnW[έקӪOH\n");
	
	arg = remove_ansi(arg);
	
	if( sscanf(arg, "-d %s", arg) == 1 )
	{
		if( !arrayp(info = EMOTE_D->query_emotion(arg)) )
			return tell(me, "S "+arg+" oӪOC\n");
		
		tell(me, emotion_detail_description(arg, info)+"TwO_R "+arg+" O(Yes/No)H");
		input_to( (: confirm_delete_emotion, me, arg :) );
		return;
	}
		
	if( arrayp(info = EMOTE_D->query_emotion(arg)) )
	{
		for(int i=0;i<8;i++)
			modifying_info[i] = info[i];
	}
	else
	{
		if( !valid_emote_name(arg) )
			return tell(me, "XkOW١C\n");
			
		modifying_info[NOTE] = 0;
		modifying_info[USE] = 0;
	}
		
	tell(me, emotion_detail_description(arg, modifying_info)+"пJ]w(]w save, ]w exit)G\n>");
	input_to( (: choose_option, me, arg, modifying_info :) );
}