/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : bulletin_board.c
 * Author : Clode@RevivalWorld
 * Date   : 2001-3-21
 * Note   : зǯdO~
 * Update :
 *  o 2000-00-00  
 *
 -----------------------------------------
 */

#include <ansi.h>
#include <feature.h>
#include <daemon.h>
#include <message.h>

#define BOARD_DATA_PATH		"/data/board/"

#define AUTHOR		0
#define TITLE		1

inherit MOVE;
inherit IDNAME;
inherit DATABASE;
inherit ACTION;

mapping actions;

// ɦWƧǰ}C
// POST_SORT = ({ ɮint}C(wƧ) })
//int *POST_SORT = ({});

// Author P Title Kn֨
// SUMMARY = ([ ɮ(): ({ @, D }) ]);
//mapping SUMMARY = ([]);

void do_read(object me, string arg);
void do_post(object me, string arg);
void do_discard(object me, string arg);
void do_followup(object me, string arg);
void do_mail(object me, string arg);

int is_board()
{
	return 1;
}

void startup_action()
{
	actions = 
	([ 
	    "post"		:(: do_post :),
	    "read"		:(: do_read :),
	    "discard"		:(: do_discard :),
	    "followup"		:(: do_followup :),
	    "mail"		:(: do_mail :), 
	]);
}

// dODlƸJ
void initialize_board()
{
	int i, *post_sort = ({});
	string file, path, *elem;
	mapping summary = ([]);

	path = copy(set("savepath", BOARD_DATA_PATH + query("boardid") + "/"));

	// YSdOؿhإ
	if( file_size(path) != -2 ) mkdir(path);

	// ŪsƩҦd
	else foreach( file in get_dir(path) )
	{
		i = to_int(file);

		elem = allocate(2);
		sscanf( read_file(path+file,1,1), "%s|%s\n", elem[AUTHOR], elem[TITLE] );
		summary[i] = elem;
		post_sort += ({ i });
	}

	set("summary", summary);
	set("post_sort", post_sort);
	set("mass",-1);
}


string short()
{
	int *post_sort = copy(query("post_sort"));

	int unread, size, last_read = query("board_last_read/"+query("boardid"), this_player()) || 0;

	if( !(size = sizeof(post_sort)) ) return ::short()+" "+NOR WHT+"["NOR" Sd "WHT"]"NOR;

	unread = sizeof(filter_array(post_sort, (: $1 > $(last_read) :)));

	return ::short() +" "+NOR WHT+"[ "NOR+ size +" id " + (unread ? "M"+unread+" iŪ"WHT"]"NOR : WHT"]"NOR);
}

string long()
{
	string str;
	int i, index, last_read = query("board_last_read/"+query("boardid"), this_player());
	int *post_sort = copy(query("post_sort"));
	mapping summary = copy(query("summary"));

	str = sprintf("\n%-34s%s", this_object()->query_idname(), NOR WHT"wwwwwwwwwwwwwwwwwwwwwwwww\n\n"NOR);

	foreach( index in post_sort )
	str += sprintf("%s[%4d] %s %-26s %-30s <%15s>\n",(index>last_read?HIY:""), ++i, NOR, summary[index][0], summary[index][1], TIME_D->replace_ctime(index));

	str += NOR WHT"\nwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww\n\n"NOR;

	return str;
}

void done_post(object me, int time, string arg)
{
	// ñW
	string sig = query("signature", me);
	string *info = copy(query("summary"))[time];

	arg = info[AUTHOR]+"|"+info[TITLE]+"\n"+arg+(sig ? "\n\n"NOR WHT"ww\n"NOR+sig+NOR : NOR);

	if( write_file( (string)query("savepath")+time, arg ) )
	{
		set("post_sort", query("post_sort") + ({ time }), find_object(base_name(this_object())));
		tell(me, "dC\n");
		set_temp("lastpost/time", time(), me);
		me->finish_input();
	}
	else
		return tell(me, "dѡAгqŮvBzC\n");
}

void do_post(object me, string arg)
{
	int time = time();
	mapping summary = copy(query("summary"));

	if(!arg)
		return tell(me, "Ьz峹w@ӼDC\n");

	if( noansi_strlen(arg) > 26 )
		return tell(me, "ADӪFAYuADC\n");

	if( time() - query_temp("lastpost/time", me) < 20 )
		return tell(me, "pثeoɶj 20 C\n");

	while( member_array(time, query("post_sort"))+1 ) time++;
	summary[time] = ({ me->query_idname(), arg });
	set("summary", summary, find_object(base_name(this_object())));

	me->edit( (: done_post, me, time :) );
}

void do_discard(object me, string arg)
{
	int num, file;
	int *post_sort = copy(query("post_sort"));
	mapping summary = copy(query("summary"));

	if( !arg || !sscanf(arg, "%d", num) )
		return tell(me, "пJwR峹sC\n");

	if( num < 1 || num > sizeof(post_sort) )
		return tell(me, "SoidC\n");

	file = post_sort[--num];

	if( me->query_idname() != summary[file][AUTHOR] )
	{
		string author_id;
		sscanf( remove_ansi(summary[file][AUTHOR]), "%*s(%s)", author_id );
		author_id = lower_case(author_id);
		if( me->query_id(1) != author_id 
		    && (!wizardp(me) || SECURE_D->level_num(author_id) > SECURE_D->level_num(me->query_id(1)) )
		    && !CITY_D->is_mayor(query("city"), me))
			return tell(me, "oidO"+ pnoun(2, me) +"gC\n");
	}

	if( rm(query("savepath")+(file<1000000000?"0":"")+file) )
	{
		set("post_sort", post_sort - ({ file }), find_object(base_name(this_object())));
		map_delete(summary, file);
		set("summary", summary, find_object(base_name(this_object())));
		tell(me, "RC\n");
	}
	else tell(me, "RѡAгqŮvBzC\n");
}

void do_read(object me, string arg)
{
	string msg;
	int num, last_read, file;
	int *post_sort = copy(query("post_sort"));
	mapping summary = copy(query("summary"));

	last_read = query("board_last_read/"+query("boardid"), me);


	if( !arg || arg == "new" || arg == "next" )
		num = (last_read ? sizeof(filter_array(post_sort, (: $1 <= $(last_read) :))) : 0) + 1;

	else if( !sscanf(arg, "%d", num) )
		return tell(me, "AnŪĴXidS\n");

	if( num < 1 || num-1 > sizeof(post_sort) )
		return tell(me, "SoidC\n");

	else if( num-1 == sizeof(post_sort) )
		return tell(me, "SsdC\n");

	file = post_sort[--num];

	msg = sprintf("[1;46mg [m %-27s[1;46m@ [m %s\n[1;46mD D[m %-27s[1;46m [m %s[m\nwwwwwwwwwwwww[1;30m[[1;37mContent[m[1;30m][mwwwwwwwwwwwwww\n%s\n%s",
	    ""+CHINESE_D->chinese_number(num+1)+"g",
	    summary[file][AUTHOR],
	    summary[file][TITLE],
	    TIME_D->replace_ctime(file),
	    read_file(query("savepath")+(file<1000000000?"0":"")+file, 2),
	    "wwwwwwwwwwwwww[1;30m[[1;37mEnd[m[1;30m][mwwwwwwwwwwwwwww\n\n"
	);

	me->more( msg );

	if( file >= last_read ) set("board_last_read/"+query("boardid"), file, me);
}

void do_followup(object me, string arg)
{
	int num, file, time = time();
	string msg="", new_title;
	int *post_sort = copy(query("post_sort"));
	mapping summary = copy(query("summary"));

	if( !arg )
		return tell(me, "пJ^Ъ峹s last ^г̫@g峹C\n");
	if( arg == "last" ) num = sizeof(post_sort)-1;
	else if( !sscanf(arg, "%d", num) || !sscanf(arg, "%d %s", num, new_title) )
		return tell(me, "пJ^Ъ峹sC\n");
	else if( arg == "last" ) num = sizeof(post_sort);

	if( num < 1 || num > sizeof(post_sort) )
		return tell(me, "SoidC\n");

	if( new_title && noansi_strlen(new_title) > 26 )
		return tell(me, "ADӪFAYuADC\n");

	file = post_sort[num-1];

	foreach( string word in explode( read_file(query("savepath")+(file<1000000000?"0":"")+file, 2), "\n" ) )
	{
		if( word == "" || word[0..7]=="[1;30m>" ) continue;
		else if( word == NOR WHT"ww" ) break;
		else if( word[0..5] == "[33m>" ) msg += "[1;30m> "+word[5..]+"\n";
		else if( word[0..5] == "[36m>" ) msg += "[33m> "+word[5..]+"\n";
		else msg += "[36m> "+word+"\n";
	}

	if( msg[0..5] == "[36m>" ) 
		msg = "[36m> "+summary[file][AUTHOR]+" b "+TIME_D->replace_ctime(file)+" dUogdR\n" + msg;

	msg += "\n"+me->query_idname()+" b "+TIME_D->replace_ctime(time)+" dUogdR\n";

	while( member_array(time, post_sort)+1 ) time++;
	set("summary", summary + ([ time : ({ me->query_idname(), (new_title || (summary[file][TITLE][0..5]!="^СG"?"^СG":"")) + summary[file][TITLE] }) ]), find_object(base_name(this_object())));

	me->edit( (: done_post, me, time :), msg );
}

void do_mail(object me, string arg)
{
	int file, num, *post_sort = copy(query("post_sort"));
	string msg, email;
	mapping summary = copy(query("summary"));

	if( !arg || !sscanf(arg, "%d", num) )
		return tell(me, "O榡: mail <峹s>\n");

	if( num < 1 || num > sizeof(post_sort) )
		return tell(me, "SoidC\n");

	if( !wizardp(me) )
		return tell(me, "\|}񪱮aϥΡC\n");

	if( !stringp(email = query("email", me)) )
		return tell(me, "zS]wqllC\n");

	file = post_sort[--num];

	msg = "HUT ͪ@(Revival World)\n\n";
	msg += sprintf("[1;46mg [m %-27s[1;46m@ [m %s\n[1;46mD D[m %-27s[1;46m [m %s[m\nwwwwwwwwwwwww[1;30m[[1;37mContent[m[1;30m][mwwwwwwwwwwwwww\n%s\n%s",
	    ""+CHINESE_D->chinese_number(num+1)+"g",
	    summary[file][AUTHOR],
	    summary[file][TITLE],
	    TIME_D->replace_ctime(file),
	    read_file(query("savepath")+(file<1000000000?"0":"")+file, 2),
	    "wwwwwwwwwwwwww[1;30m[[1;37mEnd[m[1;30m][mwwwwwwwwwwwwwww\n\n"
	);
	msg = remove_ansi(msg);
	SMTP_D->mail(email, msg, "ͪ@(Revival World) - 峹");
	tell(me, "峹weXܱz E-mail HcC\n");
}

