/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : cityhall.c
 * Author : Clode@RevivalWorld
 * Date   : 2002-2-24
 * Note   : FjӰʧ@~Ӫ
 * Update :
 *  o 2000-00-00  
 *
 -----------------------------------------
 */

#include <ansi.h>
#include <map.h>
#include <daemon.h>
#include <feature.h>
#include <message.h>

inherit ROOM_ACTION_MOD;

#define LAND_DOMINIUM	"/obj/etc/land_dominium"

#define UNREGISTER_MONEY		"100000"
#define DEFAULT_NEWBIE_MONEY		"1000"

#define CITY_IDNAME_CHANGE_COST		"500000000"

// nOO
void do_register(object me, string arg)
{
	string city, money_unit;
	object env = environment(me);

	city = env->query_city();
	
	if( CITY_D->is_citizen(me->query_id(1), city) )
		return tell(me, pnoun(2, me)+"wgO"+CITY_D->query_city_idname(city)+"FC\n");
	
	if( CITY_D->is_citizen(me->query_id(1), query("city", me))  )
		return tell(me, pnoun(2, me)+"쥻b"+CITY_D->query_city_idname(query("city", me))+"yC\n");
	
	if( wizardp(me) && city != "wizard" )
		return tell(me, "ŮvJyaKyCC\n");

	if( CITY_D->register_citizen(me->query_id(1), city) )
	{
		set("city", city, me);
		
		msg("$MENnaƪdxpjAV"+CITY_D->query_city_idname(city)+"FnOC\n",me,0,1);
		
		if( !sizeof(filter_array(all_inventory(me), (: base_name($1) == LAND_DOMINIUM :))) )
			new(LAND_DOMINIUM)->move(me);
		
		money_unit = MONEY_D->city_to_money_unit(city);
		
		me->earn_money(money_unit, DEFAULT_NEWBIE_MONEY);
		
		msg("dxpj_ө^WF@gaҦv$MEAõo "HIY+money(money_unit, DEFAULT_NEWBIE_MONEY)+NOR" ϧU$MEC\n", me, 0, 1);
		
		CHANNEL_D->channel_broadcast("news", me->query_idname()+"V"+CITY_D->query_city_idname(city)+"FnOC");
		CHANNEL_D->channel_broadcast("city", me->query_idname()+"V"+CITY_D->query_city_idname(city)+"FnOC", me);
		me->save();
		set_temp("city_register_time", time(), me);
		return;
	}
	
	return tell(me, "nOѡC\n");
}

void do_confirm_unregister(object me, string city, string arg)
{
	string money_unit = MONEY_D->city_to_money_unit(city);

	if( !arg || !arg[0] )
		return tell(me, pnoun(2, me)+"FPyʧ@C\n");

	arg = lower_case(arg);

	if( arg != "yes" && arg[0..0] == "y" )
	{
		tell(me, HIY"Y"+pnoun(2, me)+"TwnPܽпJ'yes'C\n"+pnoun(2, me)+"TwnP"+CITY_D->query_city_idname(city)+HIY"yH(Yes/No)"NOR);
		input_to((: do_confirm_unregister, me, city:));
		return;
	}
	
	if( arg != "yes" )
	{
		tell(me, pnoun(2, me)+"FPyʧ@C\n");
		me->finish_input();
		return;
	}

	if( query("total_online_time", me) > 7*24*60*60 && !me->spend_money(money_unit, UNREGISTER_MONEY) )
	{
		tell(me, pnoun(2, me)+"Pyݭnú $"+money_unit+" "+UNREGISTER_MONEY+"C\n");
		me->finish_input();
		return;
	}

	if( CITY_D->remove_citizen(me->query_id(1)) )
	{
		delete("city", me);
		
		msg("$MEVdxpjnOPFb"+CITY_D->query_city_idname(city)+"C\n", me, 0, 1);
		
		if( present("land dominium", me) )
			destruct(present("land dominium", me));

		me->spend_money(money_unit, DEFAULT_NEWBIE_MONEY);

		ESTATE_D->remove_estate(me->query_id(1));
		CHANNEL_D->channel_broadcast("news", me->query_idname()+"PFb"+CITY_D->query_city_idname(city)+"yC");
		
		me->save();
		me->finish_input();

		return;
	}
	me->finish_input();
	return tell(me, "PѡC\n");
}

// P
void do_unregister(object me, string arg)
{
	string city = query("city", me);

	if( !CITY_D->city_exist(city) )
		return tell(me, pnoun(2, me)+"ݩ@yC\n");

	if( !CITY_D->is_citizen(me->query_id(1), city) )
		return tell(me, pnoun(2, me)+"ӴNO"+CITY_D->query_city_idname(city)+"C\n");

	if( CITY_D->is_mayor(city, me) )
		return tell(me, pnoun(2, me)+"OPC\n");

	if( time() - query_temp("city_register_time", me) < 600 )
		return tell(me, pnoun(2, me)+" "+(time() - query_temp("city_register_time", me))+" ~PC\n");

	tell(me, HIR"\n\nPN|"+pnoun(2, me)+"ॢbҦgaPؿvåBovC\n"HIY+pnoun(2, me)+"TwnP"+CITY_D->query_city_idname(city)+HIY"yH(Yes/No)"NOR);

	input_to((: do_confirm_unregister, me, city:));
}

void do_citizen(object me, string arg)
{
	int i;
	string msg="";
	string city = environment(me)->query_city();
	
	msg = CITY_D->query_city_idname(city)+"WpU(̷ӤJy)G\n";
	
	foreach( string id in CITY_D->query_citizens(city) )
		msg += sprintf("%-15s%s", capitalize(id), ++i%6 ? "" : "\n");
	
	return tell(me, msg+"\n\n");
}

void reset_election_roomlong(object env)
{
	int i;
	mapping election = query("election", env);
	string msg = "";
	
	if( election )
	{
		msg += HIW"\n벼DDG"HIC+election["title"]+NOR WHT"\nwwwwwwwwwwwwwwwwwwwwwwwwwwwwww\n"NOR;
		msg += HIG"}nOѿG"NOR+(election["candidate"] ? "O" : "_")+"\n";
	
		if( election["end"] )
			msg += HIG"벼}lɶG"NOR+(election["start"] ? election["start"]/60/60/24+"  "+election["start"]/60/60%24+"  "+election["start"]/60%60+" " : "wg}l")+"\n";
		
		if( election["announced"] )
			msg += HIG"벼ɶG"NOR+(election["end"] ? (election["end"]/60/60/24)+"  "+(election["end"]/60/60%24)+"  "+(election["end"]/60%60)+" " : "wg")+"\n";

		msg += NOR WHT"wwwwwwwwwwwwwwwwwwwwwwwwwwwwww\n"HIW"벼ءG\n\n"NOR;
		
		if( election["option"] )
		{
			foreach(string option, mapping data in election["option"] )
				msg += sprintf(HIR"%2d"NOR RED" - "NOR"%-50s %d \n", ++i, data["candidate"]||option, sizeof(data["vote"]));
		}
		else
			msg += "    Lﶵ\n";
		
		msg += NOR WHT"wwwwwwwwwwwwwwwwwwwwwwwwwwwwww\n"NOR;
		set("long", msg, env);
	}
	else
		set("long", "ثeS벼ʡC", env);
}

string query_pcolor(int percent)
{
	switch(percent)
	{
		case 0..30:
			return HIR+percent+"%"NOR;
		case 31..70:
			return HIY+percent+"%"NOR;
		case 71..100:
			return HIG+percent+"%"NOR;
		case 101..120:
			return HIC+percent+"%"NOR;
		default:
			return HIW+percent+"%"NOR;
	}
}

void heart_beat(object env)
{
	switch( query("function", env) )
	{
		case "election":
		{
			int time = time();
			mapping election = query("election", env) || allocate_mapping(0);
			
			if( !((time-120)%1800) )
			{
				set("city", env->query_city(), env);
				
				if( election["announced"] && !election["ended"] )
					CHANNEL_D->channel_broadcast("city", "Fb|u"+election["title"]+"v벼ʡAпDѻP벼C", env);
			}
			
			if( !(time%1800) )
				env->save();

			if( election["announced"] )
			{
				if( !election["started"] && addn("election/start", -1, env) <= 0 )
				{
					set("election/started", 1, env); // w}l
					delete("election/start", env);
					env->save();
				}
				
				if( !election["ended"] && addn("election/end", -1, env) <= 0 )
				{
					set("election/ended", 1, env); // w
					delete("election/end", env);
					env->save();
				}
				reset_election_roomlong(env);
			}
			break;
		}	
	}
}

void do_refresh(object me, string arg)
{
	object env = environment(me);
	string msg, estatetax;
	string city = env->query_city();
	string moneyunit = MONEY_D->city_to_money_unit(city);
	int num = CITY_D->query_city_num(city);
	mapping fund = CITY_D->query_city_info(city, "fund") || allocate_mapping(0);
	mapping facilities = CITY_D->query_public_facility(city);
	mapping money = CITY_D->query_city_fund(city);
	string totalreceipt, totalexpense, estatecost;

	estatetax = TAX_D->query_city_tax(city);

	totalreceipt = count(estatetax, "+", totalreceipt);
	
	foreach( string id, mixed m in money )
		totalexpense = count( totalexpense, "+", m );

	foreach( string citizen in CITY_D->query_citizens(city) )
		estatecost = count( estatecost, "+", count(ESTATE_D->query_all_estate_value(citizen), "/", 15000));
	
	totalexpense = count( totalexpense, "+", estatecost);

	msg  = "zwwwwwwwwwwwwwwww "HIG"sɶ "+TIME_D->replace_ctime(time())+NOR"  {\n";
	msg += "U"+sprintf("%-60s", CITY_D->query_city_idname(city)+"]FT")+"U\n";
	msg += "uwwwwwwwwwwwww"HIR"F"NOR RED"X"NOR"wwwwwwwwwwwwwt\n";

	msg += "U"HIW"۵M귽          ƶq       ۵MO|             һݪB"NOR"  U\n";
	msg += sprintf("U  %-16s%-12s%7s"HIR"%21s"NOR"  U\n", NOR YEL"s"NOR, num+" y", query_pcolor(fund["s"]), money(moneyunit, money["s"]));
	msg += sprintf("U  %-16s%-12s%7s"HIR"%21s"NOR"  U\n", NOR HIG"˪L"NOR, num+" y", query_pcolor(fund["˪L"]), money(moneyunit, money["˪L"]));
	msg += sprintf("U  %-16s%-12s%7s"HIR"%21s"NOR"  U\n", NOR HIB"ey"NOR, num+" y", query_pcolor(fund["ey"]), money(moneyunit, money["ey"]));
	msg += "U                                                            U\n";
	msg += "U"HIW"@X          ƶq       @Oi             һݪB"NOR"  U\n";
	msg += sprintf("U  %-16s%-12d%7s"HIR"%21s"NOR"  U\n", NOR WHT"D"NOR, facilities["D"], query_pcolor(fund["D"]), money(moneyunit, money["D"]));
	msg += sprintf("U  %-16s%-12d%7s"HIR"%21s"NOR"  U\n", NOR RED""NOR, facilities[""], query_pcolor(fund[""]), money(moneyunit, money[""]));
	msg += sprintf("U  %-16s%-12d%7s"HIR"%21s"NOR"  U\n", HIY"av"NOR, facilities["Ŧa"], "- ", money(moneyunit, money["Ŧa"]));
	msg += "U                                                            U\n";
	msg += "U"HIW"BX          ƶq       B޲z             һݪB"NOR"  U\n";
	msg += sprintf("U  %-16s%-12d%7s"HIR"%21s"NOR"  U\n", HIM"Fؿv"NOR, 	facilities["@ؿv"], "- ", money(moneyunit, money["@ؿv"]));
	msg += sprintf("U  %-16s%-12s%7s"HIR"%21s"NOR"  U\n", HIC"a޲z"NOR, 	"- ", "- ", money(moneyunit, estatecost));
	msg += "U                                                            U\n";
	msg += sprintf("U  "HIR"`X     %45s"NOR"  U\n", money(moneyunit, totalexpense));
	msg += "uwwwwwwwwwwwww"HIG"F"NOR GRN"J"NOR"wwwwwwwwwwwwwt\n";
	msg += "U"HIW"|J                         |v             x|B"NOR"  U\n";
	msg += sprintf("U  %-28s%7d"HIG"%21s"NOR"  U\n", "a|", CITY_D->query_city_info(city, "estatetax"), money(moneyunit, estatetax));
	msg += "U                                                            U\n";
	msg += sprintf("U  "HIG"`J     %45s"NOR"  U\n", money(moneyunit, totalreceipt));
	msg += "uwwwwwwwwwwwww"HIY""NOR YEL"έp"NOR"wwwwwwwwwwwwwt\n";
	msg += sprintf("U  W]F "HIY"%43s"NOR"  U\n", money(moneyunit, CITY_D->query_city_info(city, "last_total_gain")));
	msg += sprintf("U  wp "HIY"%43s"NOR"  U\n", money(moneyunit, count(totalreceipt, "-", totalexpense)));
	msg += "|wwwwwwwwwwwwwwwwwwwwwwwwwwwwww}\n";
	msg += NOR YEL" пJ "HIY"refresh"NOR YEL" Oӧs̷s]FέpƦrC\n"NOR;
				
	set("long", msg, env);
	tell(me, "s]FTC\n");

	env->save();
}

void do_election_manage(object me, string arg)
{
	mixed option;
	object env = environment(me);
	string city = env->query_city();
	mapping election = query("election", env);

	if( !arg )
		return tell(me, "аѦ help manage OC\n");
	
	if( !CITY_D->is_mayor_or_officer(city, me) )
		return tell(me, pnoun(2, me)+"OoyΩxALk޲z벼cC\n");

	if( sscanf(arg, "new %s", option) )
	{
		if( noansi_strlen(option) > 30 )
			return tell(me, "DDW٤WL 30 ӦrC\n");
		
		if( sizeof(election) )
			return tell(me, "ثewgt@ӧ벼DDbB@C\n");
		
		option = kill_repeat_ansi(option+NOR);
		set("election/title", option, env);
		tell(me, pnoun(2, me)+"]w벼DDu"+option+"vC\n");
	}
	else if( arg == "delete" )
	{
		if( !election )
			return tell(me, "ثeS벼ʡC\n");
		
		if( election["announced"] )		
			CHANNEL_D->channel_broadcast("city", NOR YEL+me->query_idname()+NOR YEL"F벼ʡu"HIY+election["title"]+NOR YEL"vC"NOR, me);

		tell(me, "RҦ벼ơC\n");
		delete("election", env);
	}
	else if( arg == "candidate" )
	{
		if( !election["title"] )
			return tell(me, "Х]w벼DDC\n");

		if( election["announced"] )
			return tell(me, "벼ʤwgiALkAק]wC\n");

		if( election["candidate"] )
		{
			tell(me, "\ԿHnOѿC\n");
			delete("election/candidate", env);
		}
		else
		{
			tell(me, "}ԿHnOѿC\n");
			set("election/candidate", 1, env);
		}
	}
	else if( sscanf(arg, "option %s", option) )
	{
		if( !election["title"] )
			return tell(me, "Х]w벼DDC\n");

		if( election["announced"] )
			return tell(me, "벼ʤwgiALkAק]wC\n");

		if( query("election/option/"+option, env) )
		{
			tell(me, "R벼ءu"+option+"vC\n");	
			delete("election/option/"+option, env);
		}
		else
		{
			tell(me, "W[벼ءu"+option+"vC\n");
			set("election/option/"+option+"/candidate", 0, env);
		}
	}
	else if( sscanf(arg, "start %d", option) )
	{
		if( !election["title"] )
			return tell(me, "Х]w벼DDC\n");

		if( election["announced"] )
			return tell(me, "벼ʤwgiALkAק]wC\n");

		if( option < 0 || option > 240 )
			return tell(me, "벼}lɶûݦb 0  240 pɤC\n");

		if( election["end"] && option*3600 >= election["end"] )
			return tell(me, "벼}lɶnb벼ɶeC\n");
			
		set("election/start", option*3600, env);
		tell(me, pnoun(2, me)+"]wbG벼ʪ "+option+" Ӥpɫ}l벼C\n");
	}
	else if( sscanf(arg, "end %d", option) )
	{
		if( !election["title"] )
			return tell(me, "Х]w벼DDC\n");

		if( election["announced"] )
			return tell(me, "벼ʤwgiALkAק]wC\n");

		if( option < 0 || option > 480 )
			return tell(me, "벼}lɶûݦb 0  480 pɤC\n");

		if( option*3600 <= election["start"] )
			return tell(me, "벼ɶnb벼}lɶC\n");

		set("election/end", option*3600, env);
		tell(me, pnoun(2, me)+"]wbG벼ʪ "+option+" Ӥpɫᵲ벼C\n");
		
	}
	else if( arg == "announce" )
	{
		if( !election["title"] )
			return tell(me, "L벼DDC\n");
		if( !election["end"] )
			return tell(me, "]벼ɶC\n");
		if( election["announced"] )
			return tell(me, "벼ʤwgiC\n");

		if( !election["start"] )
			set("election/started", 1, env);

		set("election/announced", 1, env);
		
		heart_beat(env);
		
		CHANNEL_D->channel_broadcast("city", NOR YEL+me->query_idname()+NOR YEL"bF|쪺벼ʡu"HIY+election["title"]+NOR YEL"v}lC"NOR, me);
	}
	else tell(me, "аѦ help manage OC\n");
	
	reset_election_roomlong(env);
	env->save();
}

void do_election_register(object me, string arg)
{
	object env = environment(me);
	string city = env->query_city();
	string myid = me->query_id(1);
	mapping election = query("election", env);

	if( !CITY_D->is_citizen(myid, city) )
		return tell(me, pnoun(2, me)+"O"+CITY_D->query_city_idname(city)+"C\n");

	if( !election )
		return tell(me, "ثeS벼ʡC\n");

	if( query("total_online_time", me) < 30*24*60*60 )
		return tell(me, pnoun(2, me)+"`Wuɶ|WL 30 ѡALknOԿHC\n");
	
	if( !election["candidate"] )
		return tell(me, "벼}ԿHnOC\n");

	if( query("election/option/"+myid, env) )
	{
		delete("election/option/"+myid, env);
		reset_election_roomlong(env);
		CHANNEL_D->channel_broadcast("city", NOR YEL+me->query_idname()+NOR YEL"ѿu"HIY+election["title"]+NOR YEL"vC"NOR, me);
		return;
	}
		
	if( election["ended"] )
		return tell(me, "벼wgC\n");

	if( election["started"] )
		return tell(me, "wg}l벼ALkAinOC\n");

	set("election/option/"+myid+"/candidate", me->query_idname(), env);
	
	reset_election_roomlong(env);
	CHANNEL_D->channel_broadcast("city", NOR YEL+me->query_idname()+NOR YEL"nOѿu"HIY+election["title"]+NOR YEL"v벼ʡC"NOR, me);
	
	env->save();
}

void do_election_vote(object me, string arg)
{
	int i;
	object env = environment(me);
	string city = env->query_city();
	string myid = me->query_id(1);
	mapping election = query("election", env);

	if( !arg || !to_int(arg) )
		return tell(me, "пJ"+pnoun(2, me)+"Qn벼ﶵsC\n");

	if( !CITY_D->is_citizen(myid, city) )
		return tell(me, pnoun(2, me)+"O"+CITY_D->query_city_idname(city)+"C\n");

	if( !election )
		return tell(me, "ثeS벼ʡC\n");

	if( query("total_online_time", me) < 20*24*60*60 )
		return tell(me, pnoun(2, me)+"`Wuɶ|WL 20 ѡALk벼C\n");
		
	if( election["ended"] )
		return tell(me, "벼wgC\n");

	if( !election["started"] )
		return tell(me, "٥}l벼C\n");
	
	if( !election["option"] )
		return tell(me, "ثeS벼ﶵC\n");

	foreach(string option, mapping data in election["option"] )
		if( query("election/option/"+option+"/vote/"+myid, env) )
			return tell(me, pnoun(2, me)+"wgLFC\n");
	
	foreach(string option, mapping data in election["option"] )
		if( ++i == to_int(arg) )
			set("election/option/"+option+"/vote/"+myid, 1, env);
	
	reset_election_roomlong(env);
	CHANNEL_D->channel_broadcast("city", me->query_idname()+"Uu"+election["title"]+"vt@C", me);
	env->save();
}

void do_officer(object me, string arg)
{
	int num;
	int maxofficers;
	string id, title, city = environment(me)->query_city();
	mapping officers;
	object officer;
	
	officers = CITY_D->query_city_info(city, "government/officer") || allocate_mapping(0);
	
	if( CITY_D->is_officer(city, me) && arg == "quit" )
	{
		title = officers[me->query_id(1)];
		map_delete(officers, me->query_id(1));
		CITY_D->set_city_info(city, "government/officer", officers);
		
		CHANNEL_D->channel_broadcast("city", me->query_idname()+"VFhFu"+title+"vx¾ȡC", me);
		msg("$MEVFhFu"+title+"vx¾ȡC\n", me, 0, 1);
		
		for(int i=0;CITY_D->city_exist(city, i);i++)
		{
			if( CITY_D->query_section_info(city, i, "vicemayor") == me->query_id(1) )
				CITY_D->delete_section_info(city, i, "vicemayor");
		}
			
		return;
	}
	
	if( !CITY_D->is_mayor(city, me) )
		return tell(me, pnoun(2, me)+"O]w"+pnoun(2, me)+"xC\n");
		
	if( !arg )
		return tell(me, "ثexW欰G"+(sizeof(officers) ? implode(keys(officers), (: capitalize($1)+", "+capitalize($2) :)) : "L")+"\n");

	if( sscanf(arg, "%s vicemayor %d", id, num) != 2 && sscanf(arg, "%s %s", id, title) != 2 )
		return tell(me, "O榡~A help officerC\n");

	if( num > 0 )
	{
		num--;
		
		if( !CITY_D->city_exist(city, num) )
			return tell(me, "oӫS "+(num+1)+" ìPC\n");

		if( !objectp(officer = find_player(id)) )
			return tell(me, "uWS "+capitalize(id)+" o쪱aC\n");

		if( !CITY_D->is_citizen(id, city) )
			return tell(me, officer->query_idname()+"äOALkRƥC\n");
		
		maxofficers = 2+3*CITY_D->query_sections(city);
		if( undefinedp(officers[id]) && sizeof(officers) >= maxofficers )
			return tell(me, "ثe̦huPɥR "+maxofficers+" xC\n");
		
		if( !undefinedp(officers[id]) )
			return tell(me, pnoun(2, me)+"Ѱ쥻x¾C\n");

		if( CITY_D->query_section_info(city, num, "vicemayor") )
			return tell(me, pnoun(2, me)+"Ѱ "+capitalize(CITY_D->query_section_info(city, num, "vicemayor"))+" ƥ¾C\n");

		officers[id] = CITY_D->query_section_info(city, num, "name")+"ƥ";

		CITY_D->set_city_info(city, "government/officer", officers);
	
		CITY_D->set_section_info(city, num, "vicemayor", id);
		
		CHANNEL_D->channel_broadcast("city", ""+me->query_idname()+"R"+officer->query_idname()+""+CITY_D->query_city_name(city, num)+"ƥC", me);	
		
		return;
	}

	if( title == "-d" )
	{
		officer = find_player(id);
		
		if( undefinedp(officers[id]) )
			return tell(me, (objectp(officer) ? officer->query_idname() : capitalize(id)+" ")+"쥻NOxC\n");
			
		for(int i=0;CITY_D->city_exist(city, i);i++)
		{
			if( CITY_D->query_section_info(city, i, "vicemayor") == id )
				CITY_D->delete_section_info(city, i, "vicemayor");
		}

		map_delete(officers, id);
		CITY_D->set_city_info(city, "government/officer", officers);
		CHANNEL_D->channel_broadcast("city", ""+me->query_idname()+"ѰF"+(objectp(officer) ? officer->query_idname() : " "+capitalize(id)+" ")+"x¾ȡC", me);
		return;	
	}

	title = kill_repeat_ansi(title+NOR);

	if( !objectp(officer = find_player(id)) )
		return tell(me, "uWS "+capitalize(id)+" o쪱aC\n");
	
	if( !CITY_D->is_citizen(id, city) )
		return tell(me, officer->query_idname()+"äOALkRxC\n");

	maxofficers = 2+3*CITY_D->query_sections(city);
	if( undefinedp(officers[arg]) && sizeof(officers) >= maxofficers )
		return tell(me, "ثe̦huPɥR "+maxofficers+" xC\n");
		
	if( title == officers[id] )
		return tell(me, officer->query_idname()+"wgQRu"+title+"vC\n");

	officers[id] = title;
	CITY_D->set_city_info(city, "government/officer", officers);
	CHANNEL_D->channel_broadcast("city", ""+me->query_idname()+"R"+officer->query_idname()+""+CITY_D->query_city_name(city)+"u"+title+"vxC", me);	
}

void do_confirm_abdicate(object me, object target, string city, string arg)
{
	if( lower_case(arg) != "yes" )
	{
		tell(me, pnoun(2, me)+"¾쪺汵C\n");
		me->finish_input();
		return;
	}
	
	CHANNEL_D->channel_broadcast("city", me->query_idname()+"N¾汵"+target->query_idname()+"A"+target->query_idname()+"sC", me);
	CHANNEL_D->channel_broadcast("city", "ѩ󥫪汵A¦xAsFζNѷsi歫աC", me);
	CHANNEL_D->channel_broadcast("news", CITY_D->query_city_idname(city)+""+me->query_idname()+"N¾汵"+target->query_idname()+"A"+target->query_idname()+""+CITY_D->query_city_idname(city)+"sC");
	
	msg(me, "$MENLâˤ浹F$YOUAéF$YOUӻHDGuoyN浹"+pnoun(2, target)+"FAnڥvC\n", me, target, 1);
	
	CITY_D->set_city_info(city, "government/mayor", target->query_id(1));
	CITY_D->set_city_info(city, "government/officer", allocate_mapping(0));
}

void do_abdicate(object me, string arg)
{
	object targetob;
	string city = environment(me)->query_city();
	
	if( !CITY_D->is_mayor(city, me) )
		return tell(me, pnoun(2, me)+"OC\n");

	if( !arg )
		return tell(me, pnoun(2, me)+"QNä[¾֡H\n");
	
	if( !objectp(targetob = find_player(arg)) )
		return tell(me, "uWèS "+arg+" o쪱aC\n");
		
	if( !CITY_D->is_citizen(arg, city) )
		return tell(me, targetob->query_idname()+"äOALkä[C\n");
		
	if( !same_environment(me, targetob) )
		return tell(me, targetob->query_idname()+"b"+pnoun(2, me)+"ǡALk汵ä[LâC\n");

	tell(me, HIY"TwNä[¾浹"+targetob->query_idname()+HIY"ܡH(Yes/No)G"NOR);
	
	input_to((: do_confirm_abdicate, me, targetob, city:));
}

void do_denominate(object me, string arg)
{
	int num;
	string msg;
	string city = environment(me)->query_city();
	string moneyunit = environment(me)->query_money_unit();

	if( !arg )
	{
		msg = CITY_D->query_city_idname(city)+"UìPW٦pUG\n";
		
		while(CITY_D->city_exist(city, num))
		{
			msg += sprintf("%-4s%s\n", (num+1)+".", CITY_D->query_section_info(city, num, "name")||" "+(num+1)+" ìP");
			num++;
		}
	
		return tell(me, msg+"\n");
	}
	
	if( !CITY_D->is_mayor(city, me) )
		return tell(me, pnoun(2, me)+"OLkϥΦ\C\n");
	
	if( sscanf(arg, "id %s", arg) == 1 )
	{
		if( lower_case(remove_ansi(arg)) != city )
			return tell(me, "^rP{^rۦPA"+pnoun(2, me)+"ujpgPmC\n");
			
		if( !CITY_D->change_assets(city, "-"+CITY_IDNAME_CHANGE_COST) )
			return tell(me, "F겣 "HIY+money(moneyunit, CITY_IDNAME_CHANGE_COST)+NOR" Lkܧ^W١C\n");
			
		arg = remove_fringe_blanks(kill_repeat_ansi(arg+NOR));

		CHANNEL_D->channel_broadcast("news", CITY_D->query_city_idname(city)+""+me->query_idname()+"oGGۤ_^W٧Wu"+arg+"vC\n");
		tell(me, pnoun(2, me)+"O겣 "HIY+money(moneyunit, CITY_IDNAME_CHANGE_COST)+NOR" ܧ󫰥^W١C\n");

		CITY_D->set_city_info(city, "color_id", arg);

		return;
	}
	
	if( sscanf(arg, "name %s", arg) == 1 )
	{
		int strlen = noansi_strlen(arg);
		
		if( strlen < 2 || strlen > 10 )
			return tell(me, "W٦rƥ 1 - 5 ӤrC\n");
		
		if( !is_chinese(arg) )
			return tell(me, "W٥uϥΤC\n");
			
		if( !CITY_D->change_assets(city, "-"+CITY_IDNAME_CHANGE_COST) )
			return tell(me, "F겣 "HIY+money(moneyunit, CITY_IDNAME_CHANGE_COST)+NOR" Lkܧ󤤤W١C\n");

		arg = remove_fringe_blanks(kill_repeat_ansi(arg+NOR));

		CHANNEL_D->channel_broadcast("news", CITY_D->query_city_idname(city)+""+me->query_idname()+"oGGۤ_W٧Wu"+arg+"vC\n");
		tell(me, pnoun(2, me)+"O겣 "HIY+money(moneyunit, CITY_IDNAME_CHANGE_COST)+NOR" ܧ󫰥W١C\n");

		CITY_D->set_city_info(city, "name", arg);

		return;
	}

	if( sscanf(arg, "-symbol %d %s", num, arg) == 2 )
	{
		int strlen;
		string *emblem = CITY_D->query_city_info(city, "emblem");

		if( num < 1 || num > 3 )
			return tell(me, "uw 1  3 檺O@ܧC\n");
		
		arg = kill_repeat_ansi(replace_string(arg, "\n", "")+NOR);
		
		strlen = noansi_strlen(arg);

		if( strlen > 10 )
			return tell(me, "CO̦h 10 ӦrC\n");

		if( strlen < 10 )
		{
			switch(strlen)
			{
				case 1:arg = "    "+arg+"     ";break;
				case 2:arg = "    "+arg+"    ";break;
				case 3:arg = "   "+arg+"    ";break;
				case 4:arg = "   "+arg+"   ";break;
				case 5:arg = "  "+arg+"   ";break;
				case 6:arg = "  "+arg+"  ";break;
				case 7:arg = " "+arg+"  ";break;
				case 8:arg = " "+arg+" ";break;
				case 9:arg = arg+" ";break;
			}
			
		}			
		emblem[num-1] = arg;
		
		CITY_D->set_city_info(city, "emblem", emblem);
		
		msg("$ME﫰O@Fu"+arg+"vܧC\n", me, 0, 1);
		return;
	}
		
		
		
	if( sscanf(arg, "%d %s", num, arg) != 2 )
		return tell(me, "аѦ help denominate TO榡C\n");
	
	if( !CITY_D->city_exist(city, num-1) )
		return tell(me, "èS "+num+" ìPC\n");

	arg = kill_repeat_ansi(replace_string(arg, "\n", "")+NOR);
	
	if( noansi_strlen(arg) > 10 )
		return tell(me, "ìPW٪׳̦h 10 ӦrC\n");
	
	CITY_D->set_section_info(city, num-1, "name", arg);
	CHANNEL_D->channel_broadcast("city", me->query_idname()+"N"+CITY_D->query_city_idname(city)+" "+num+" ìPWٳ]wu"+arg+"vC", me);
	return tell(me, pnoun(2, me)+"N"+CITY_D->query_city_idname(city)+" "+num+" ìPWٳ]wu"+arg+"vC\n");
}

void do_donate(object me, string arg)
{
	string myid = me->query_id(1);
	object env = environment(me);
	string city = env->query_city();
	string moneyunit = MONEY_D->city_to_money_unit(city);
	
	if( !CITY_D->is_citizen(myid, city) )
		return tell(me, pnoun(2, me)+"OLkmC\n");

	if( !arg )
	{
		string msg;
		mapping donate = query("donate", env);
		
		if( !sizeof(donate) )
			return tell(me, "ثe|L󮽴ڡC\n");
			
		msg = "FgOmWpUG\n";
		foreach(string id, mapping data in donate)
			msg += sprintf("%-40s%s\n", data["idname"], "$"+moneyunit+" "+NUMBER_D->number_symbol(data["money"]));
			
		return me->more(msg+"\n");
	}
	
	else if(!(arg = big_number_check(arg)))
		return tell(me, "пJTڪBC\n");
		
	if( count(arg, "<", 10000) )
		return tell(me, "̤֮ڪB $"+moneyunit+" 10,000 C\n");
	
	if( !me->spend_money(moneyunit, arg) )
		return tell(me, pnoun(2, me)+"WSoh $"+moneyunit+" {C\n");
	
	set("donate/"+myid, (["idname" : me->query_idname(), "money" : count(arg, "+", query("donate/"+myid+"/money", env)) ]), env);

	env->save();
	CITY_D->change_assets(city, arg);
	CHANNEL_D->channel_broadcast("city", me->query_idname()+"mF $"+moneyunit+" "+NUMBER_D->number_symbol(arg)+" @FgOΡC", me);

	return tell(me, pnoun(2, me)+"mF $"+moneyunit+" "+NUMBER_D->number_symbol(arg)+" @FgOΡC\n");
}

void do_fire(object me, string arg)
{
	object env = environment(me);
	string city = env->query_city();
	
	if( !CITY_D->is_mayor(city, me) )
		return tell(me, pnoun(2, me)+"OLkϥΦ\C\n");
		
	if( !arg )
		return tell(me, pnoun(2, me)+"n}@ӥyHC\n");
		
	arg = lower_case(arg);

	if( !CITY_D->is_citizen(arg, city) )
		return tell(me, capitalize(arg)+" äOC\n");
		
	if( sizeof(ESTATE_D->query_player_estate(arg)) )
		return tell(me, capitalize(arg)+" bo٦ЦaA}䥫yC\n");
		
	if( CITY_D->remove_citizen(arg) )
	{
		object player = find_player(arg) || load_user(arg);
		
		if( !objectp(player) )
			CHANNEL_D->channel_broadcast("news", me->query_idname()+"}F "+capitalize(arg)+" b"+CITY_D->query_city_idname(city)+"C");
		else
		{
			delete("city", player);
			CHANNEL_D->channel_broadcast("news", me->query_idname()+"}F"+player->query_idname()+"b"+CITY_D->query_city_idname(city)+"C");
			player->save();
			
			if( !interactive(player) )
				destruct(player);
		}
	}
	else
		error("PѡAгqŮvBzC\n");
}

void do_fund(object me, string arg)
{
	int percent;
	int taxrate;
	object env = environment(me);
	string tax, city = env->query_city();
	mapping fund = CITY_D->query_city_info(city, "fund") || allocate_mapping(0);

	if( !arg )
		return me->more(query("long", env));

	if( !CITY_D->is_mayor(city, me) )
		return tell(me, pnoun(2, me)+"OLkϥΦ\C\n");
	
	if( sscanf(arg, "%s| %d", tax, taxrate) == 2 )
	{
		if( taxrate < 0 || taxrate > 10000 )
			return tell(me, "|viC 0 ΰ 10000C\n");
			
		switch(tax)
		{
			case "a":
				CITY_D->set_city_info(city, "estatetax", taxrate);
				break;
			default:
				return tell(me, "ثeõL"+tax+"|C\n");
		}

		CHANNEL_D->channel_broadcast("city", me->query_idname()+"N"+CITY_D->query_city_idname(city)+""+tax+"|վ㬰 "+taxrate+"C\n", me);
		return tell(me, pnoun(2, me)+"N"+CITY_D->query_city_idname(city)+""+tax+"|վ㬰 "+taxrate+"C\n", me);
	}

	if( sscanf(arg, "%s %d", arg, percent) == 2 )
	{	
		if( percent < 0 || percent > 120 )
			return tell(me, "gOiC 0% ΰ 120%C\n");
			
		switch(arg)
		{
			case "s":
			case "˪L":
			case "ey":
			case "D":
			case "":
				fund[arg] = percent;
				break;
			default:
				return tell(me, "пJTIFﶵC\n");
		}
		
		CITY_D->set_city_info(city, "fund", fund);
	
		CHANNEL_D->channel_broadcast("city", me->query_idname()+"Nu"+arg+"v]FgOվ㬰 "+query_pcolor(percent)+"C", me);

		return tell(me, pnoun(2, me)+"Nu"+arg+"v]FgOվ㬰 "+query_pcolor(percent)+"C\n", me);
	}
	return tell(me, "аѦ help fund JT榡C\n");
}

// ]wؿvжA
nosave mapping action_info =
([
	"lobby"	:
	([
		"short"	: HIC"jU"NOR,
		"help"	:
			([
"topics":
@HELP
    FjU]AUإy\C
HELP,

"donate":
@HELP
m@FϥΡAΪkpUG
  donate ''		- m@Fϥ
  donate		- mW
HELP,
			]),
		"action":
			([
				"donate"	: (: do_donate :),
			]),
	]),
	
	"register" :
	([
		"short"	: HIY"Fưȩ"NOR,
		"help"	:
			([
"topics":
@HELP
    FưȩҭtdUyP~޲z~ȡC
HELP,

"register":
@HELP
nOUAΪkpUG
  register		- nOU
HELP,

"unregister":
@HELP
PyAΪkpUG
  register		- Py
HELP,

			]),
		"action":
			([
				"register"	: (: do_register :),
				"unregister"	: (: do_unregister :),
				"citizen"	: (: do_citizen :),
			]),
	]),

	"science"	:
	([
		"short"	: HIR"޵oi"NOR,
		"help"	: "LC",
		"action":
			([

			]),
	]),
	
	"election"	:
	([
		"short"	: HIG"|e|"NOR,
		"help"	:
			([
"topics":
@HELP
    |e|tdU벼~ȡC
HELP,

"register":
@HELP
nOΨѿAΪkpUG
  register		- nOѿ糧|(A@)
HELP,

"vote":
@HELP
Ut@AΪkpUG
  vote ''		- Ut@
HELP,

"manage":
@HELP
|޲zOAΪkpUG
  manage new 'DD'		- sW벼DD
  manage delete 		- R벼
  manage candidate		- ]w|O_}ԿHnO(۳]벼)
  manage option 'ﶵ'		- ۳]벼(}ԿHnO)AA]w@hR
  manage start 'p'		- ]wXpɫ벼}lAY]w 0 Yߨ}l벼(}ԿHnOɤi] 0)
  manage end 'p'		- ]wXpɫ벼
  manage announce		- oG벼Tö}lҰʧ벼
HELP,
			]),
		"heartbeat":1,
		"action":
			([
				"manage"	: (: do_election_manage :),
				"register"	: (: do_election_register :),
				"vote"		: (: do_election_vote :),
			]),
	]),

	"finance"	:
	([
		"short"	: HIM"]F"NOR,
		"help"	:
			([
"topics":
@HELP
    ]FtdU]F~ȡC
HELP,

"fund":
@HELP
]w]FgOAΪkpUG
  fund			- dҰ]F
  fund ey 80		- ]weyҫO|gO 80%
  fund a| 20	- Na|վ㬰 20
HELP,
			]),
		"heartbeat":0,
		"action":
			([
				"fund"		: (: do_fund :),
				"refresh"	: (: do_refresh :),
			]),
	]),

	"mayor"	:
	([
		"short"	: HIW"줽"NOR,
		"help"	:
			([
"topics":
@HELP
    줽ǡC
HELP,

"officer":
@HELP
RθѰx¾AΪkpUG
  officer			- ˵ثex
  officer 'ID' vicemayor 1	- RYĤ@óƥ
  officer 'ID' '¾'		- RYxA¾٥ѥ]p
  officer 'ID' -d		- ѰYx¾
  officer quit			- x¾
HELP,

"abdicate":
@HELP
¾汵OAΪkpUG
  abdicate 'ID'		- N¾汵t@쥫
HELP,

"denominate":
@HELP
RWOAΪkpUG
  denominate -symbol 1 'O'	- ܧ󫰥O 1 
  denominate -symbol 2 'O'	- ܧ󫰥O 2 
  denominate -symbol 3 'O'	- ܧ󫰥O 3 
  denominate 's' 'W'	- ]wYsìPUOW
  denominate id '^'		- ]ws^W (uܧmPjpg)(ݪO 5 겣)
  denominate name ''	- ]wsW (ݪO 5 겣)
HELP,

"fire":
@HELP
}Y쥫OAΪkpUG
fire 'ID'			- NYSЦa}
HELP,
			]),
		"action":
			([
				"officer"	: (: do_officer :),
				"abdicate"	: (: do_abdicate :),
				"denominate"	: (: do_denominate :),
				"fire"		: (: do_fire :),
			]),
	]),
]);


// ]wؿv
nosave array building_info = ({
	
	// ؿvW
	HIW"F"NOR WHT"j"NOR

	// }iؿv̤֩ж
	,6

	// ̤jۦPؿvƶq(0 N)
	,1

	// ؿvؿv, GOVERNMENT(F), ENTERPRISE(~), INDIVIDUAL(pH)
	,GOVERNMENT

	// ؿviؿvϰ, AGRICULTURE_REGION(A~), INDUSTRY_REGION(u~), COMMERCE_REGION(ӷ~)
	,AGRICULTURE_REGION | INDUSTRY_REGION | COMMERCE_REGION

	// }iO
	,"0"
	
	// ؿvռаO
	,0

	// ca^m
	,50
	
	// ̰i[\Ӽh
	,1
	
	// ̤jۦPؿvƶq(0 N)
	,0
	
	// ؿvɥN
	,1
});


