/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : enterprise.c
 * Author : Clode@RevivalWorld
 * Date   : 2005-03-31
 * Note   : ~j
 * Update :
 *  o 2000-00-00  
 *
 -----------------------------------------
 */

#include <ansi.h>
#include <map.h>
#include <feature.h>
#include <message.h>
#include <daemon.h>
#include <npc.h>
#include <condition.h>
#include <delay.h>

inherit ROOM_ACTION_MOD;

void do_invest(object me, string arg)
{
	string moneyunit, money, enterprise, default_moneyunit;
	
	if( !arg )
		return tell(me, pnoun(2, me)+"QnάOhhֿH\n");
		
	enterprise = query("enterprise", me);
	default_moneyunit = MONEY_D->query_default_money_unit();
	
	if( sscanf(arg, "$%s %s", moneyunit, money) == 2 )
	{
		moneyunit = upper_case(moneyunit);

		if( !(money = big_number_check(money)) )
			return tell(me, "пJTƦrC\n");

		if( moneyunit != default_moneyunit )
			return tell(me, "~ΪWΰhȱ $"+default_moneyunit+" fC\n");
				
		if( count(money, ">", 0) )
		{
			if( !me->spend_money(moneyunit, money) )
				return tell(me, pnoun(2, me)+"Soh{C\n");
			
			ENTERPRISE_D->change_assets(enterprise, money);
			ENTERPRISE_D->change_invest(enterprise, me->query_id(1), money);
			
			CHANNEL_D->channel_broadcast("ent", me->query_idname()+"W "HIY+money(default_moneyunit, money)+NOR" @~C\n", me);
		}
		else if( count(money, "<", 0) )
		{
			money = money[1..];

			if( !ENTERPRISE_D->change_assets(enterprise, "-"+money) )
				return tell(me, "ثe~´èShiѩPC\n");
			
			me->earn_money(default_moneyunit, money);
			ENTERPRISE_D->change_invest(enterprise, me->query_id(1), "-"+money);

			CHANNEL_D->channel_broadcast("ent", me->query_idname()+"q~Τh "HIY+money(default_moneyunit, money)+NOR"C\n", me);
		}
		else 
			return tell(me, pnoun(2, me)+"QnΰhhֿH\n");
	}
	else
		return tell(me, " help invest JTO榡C\n");
	
}

void do_read(object me, string arg)
{
	object env = environment(me);
	
	if( query("enterprise", me) != query("owner", env)[11..] )
		return tell(me, pnoun(2, me)+"Oo~Lkϥγo\ŪǡC\n");

	msg("$MEH⮳_@]gx}l\Ū...C\n", me, 0, 1);
	me->start_delay(REST_DELAY_KEY, 10, pnoun(2, me)+"b\ŪxC\n", "\ŪC\n");
        me->start_condition(FINANCEKNOWLEDGE);
}

void do_release(object me, string arg)
{
	string stockamount;
	string available_stockamount;
	string enterprise;
	object env = environment(me);
	
	if( !wizardp(me) )
		return tell(me, "դC\n");

	enterprise = query("owner", env)[11..];
	
	if( !ENTERPRISE_D->is_president(enterprise, me->query_id(1)) )
		return tell(me, pnoun(2, me)+"Ooӥ~`C\n");

	if( count(arg, "<=", 0) )
		return tell(me, "пJj 0 ƦrC\n");
		
	stockamount = count(arg, "+", ENTERPRISE_D->query_enterprise_info(enterprise, "stockamount"));
	available_stockamount = count(arg, "+", ENTERPRISE_D->query_enterprise_info(enterprise, "available_stockamount"));
	CHANNEL_D->channel_broadcast("stock", ENTERPRISE_D->query_enterprise_color_id(enterprise)+"~ΫťXѲ "HIC+NUMBER_D->number_symbol(arg)+NOR" iA`XѲ "HIC+NUMBER_D->number_symbol(stockamount)+NOR" iC\n");
	
	ENTERPRISE_D->set_enterprise_info(enterprise, "stockamount", stockamount);
	ENTERPRISE_D->set_enterprise_info(enterprise, "available_stockamount", available_stockamount);
}

// ]wؿvжA
nosave mapping action_info =
([
	"fund"	:
	([
		"short"	: WHT"Bz"NOR,
		"help"	:
			([
"topics":
@HELP
    BzaC
invest $WZ 10000	NӤHiJ~
invest $RW -10000	h^ӤH
HELP,
			]),
		"heartbeat":0,	// ڮɶ 1 
		"job": 0,
		"action":
			([
				"invest" : (: do_invest :),
			]),
	
	]),
	"reading"	:
	([
		"short"	: WHT"\Ū"NOR,
		"help"	:
			([
"topics":
@HELP
    ~ϮѫǡC
read			\Ūy
HELP,
			]),
		"heartbeat":0,	// ڮɶ 1 
		"job": 0,
		"action":
			([
				"read" : (: do_read :),
			]),
	
	]),	
	"directorate"	:
	([
		"short"	: WHT"Ʒ|"NOR,
		"help"	:
			([
"topics":
@HELP
    ~ƿ줽aC
HELP,
			]),
		"heartbeat":0,	// ڮɶ 1 
		"job": 0,
		"action":
			([
				"release" : (: do_release :),
			]),
	
	]),	
	"president"	:
	([
		"short"	: HIW"`"WHT"줽"NOR,
		"help"	:
			([
"topics":
@HELP
    ~`줽aC
HELP,
			]),
		"heartbeat":0,	// ڮɶ 1 
		"job": 0,
		"action":
			([

			]),
	]),
]);

// ]wؿv
nosave array building_info = ({
	
	// ؿvW
	WHT"~j"NOR

	// }iؿv̤֩ж
	,4

	// ̤jۦPؿvƶq(0 N)
	,5

	// ؿvؿv, GOVERNMENT(F), ENTERPRISE(~), INDIVIDUAL(pH)
	,ENTERPRISE

	// ؿviؿvϰ, AGRICULTURE_REGION(A~), INDUSTRY_REGION(u~), COMMERCE_REGION(ӷ~)
	,COMMERCE_REGION

	// }iO
	,"30000000"
	
	// ؿvռаO
	,0

	// ca^m
	,0
	
	// ̰i[\Ӽh
	,5
	
	// ̤jۦPؿvƶq(0 N)
	,0
	
	// ؿvɥN
	,1
});
