/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : jail.c
 * Author : Clode@RevivalWorld
 * Date   : 2006-02-24
 * Note   : ʺ
 * Update :
 *  o 2000-00-00  
 *
 -----------------------------------------
 */

#include <ansi.h>
#include <map.h>
#include <daemon.h>
#include <feature.h>
#include <message.h>
#include <object.h>

inherit ROOM_ACTION_MOD;

private void do_arrest(object me, string arg)
{
	object target;
	object env = environment(me);
	string city = env->query_city();
	string reason;

	if( !wizardp(me) && !CITY_D->is_mayor(city, me) )
		return tell(me, "ueǤHC\n");

	if( !arg || !arg[0] )
		return tell(me, pnoun(2, me)+"QneǤHH\n");

	if( sscanf(arg, "%s because %s", arg, reason) != 2 )
		return tell(me, "пJTO榡C\n");

	target = load_user(arg);

	if( !objectp(target) )
		return tell(me, "oӥ@ɨèSo쪱aC\n");
		
	if( !wizardp(me) && query("city", target) != city )
	{
		tell(me, target->query_idname()+"äOC\n");
		
		if( !userp(target) )
			destruct(target);

		return;
	}
	
	if( target == me )
		return tell(me, pnoun(2, me)+"LkeۤvC\n");
	
	if( query("prisoner", target) && same_environment(target, me) )
	{
		tell(me, target->query_idname()+"wgQiʺFC\n");

		if( !userp(target) )
			destruct(target);

		return;
	}

	if( wizardp(me) )
		CHANNEL_D->channel_broadcast("news", target->query_idname()+HIR"]u"HIW + reason + NOR HIR"vD"+me->query_idname()+HIR"eAiFŮvʺլdC");
	else
		CHANNEL_D->channel_broadcast("city", target->query_idname()+HIR"]u"HIW + reason + NOR HIR"vD"+me->query_idname()+HIR"eAiFFʺC", me);
	
	target->move_to_environment(me);
	
	set("prisoner", 1, target);
	set("quit_place", base_name(env), target);
	target->save();

	if( !userp(target) )
		destruct(target);
}

private void do_release(object me, string arg)
{
	object target;
	object env = environment(me);
	string city = env->query_city();
	string reason;
	
	if( !wizardp(me) && !CITY_D->is_mayor_or_officer(city, me) )
		return tell(me, "uΩxǤHC\n");

	if( !arg || !arg[0] )
		return tell(me, pnoun(2, me)+"QnǤHH\n");
		
	if( sscanf(arg, "%s because %s", arg, reason) != 2 )
		return tell(me, "пJTO榡C\n");

	target = find_player(arg);

	if( !objectp(target) )
		return tell(me, "uWèSo쪱aC\n");
		
	if( !wizardp(me) && query("city", target) != city )
		return tell(me, target->query_idname()+"äOC\n");
	
	if( target == me )
		return tell(me, pnoun(2, me)+"LkۤvC\n");
		
	if( !same_environment(me, target) )
		return tell(me, target->query_idname()+"äbBC\n");
		
	if( !query("prisoner", target) )
		return tell(me, target->query_idname()+"äO}ǡC\n");
		
	if( wizardp(me) )
	{
		CHANNEL_D->channel_broadcast("news", me->query_idname()+HIR"]u"HIW + reason + NOR HIR"vN"+target->query_idname()+HIR"qŮvʺXӡC"NOR);
		msg("$MEFۤvWǹСA^ŮvhF... \n" + NOR , target, 0, 1);
		target->move(load_object(WIZ_HALL));
	}
	else
		CHANNEL_D->channel_broadcast("city", me->query_idname()+HIR"]u"HIW + reason + NOR HIR"vN"+target->query_idname()+HIR"qFʺXӡC"NOR, me);
	
	delete("prisoner", target);
	target->save();
}

// ]wؿvжA
nosave mapping action_info =
([
	"jail"	:
	([
		"short"	: HIR"c"NOR RED""NOR,
		"help"	:
			([
"topics":
@HELP
    Ψӥ}TǤHaC
HELP,

"arrest":
@HELP
eY쪱aAΪkpUG
  arrest 'aID' because ']'	- NYuWe(O)
HELP,

"release":
@HELP
Y쪱aAΪkpUG
  release 'aID' because ']'	- NYQbʺ(PxO)
HELP,

			]),
		"action":
			([
				"arrest"	: (: do_arrest :),
				"release"	: (: do_release :),
			]),
	]),
]);


// ]wؿv
nosave array building_info = ({
	
	// ؿvW
	HIR"ʺ"NOR

	// }iؿv̤֩ж
	,1

	// ̤jۦPؿvƶq(0 N)
	,0

	// ؿvؿv, GOVERNMENT(F), ENTERPRISE(~), INDIVIDUAL(pH)
	,GOVERNMENT

	// ؿviؿvϰ, AGRICULTURE_REGION(A~), INDUSTRY_REGION(u~), COMMERCE_REGION(ӷ~)
	,AGRICULTURE_REGION | INDUSTRY_REGION

	// }iO
	,"5000000"
	
	// ؿvռаO
	,0

	// ca^m
	,-100
	
	// ̰i[\Ӽh
	,1
	
	// ̤jۦPؿvƶq(0 N)
	,0
	
	// ؿvɥN
	,1
});

