/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : postoffice.c
 * Author : Clode@RevivalWorld
 * Date   : 2006-02-21
 * Note   : l
 * Update :
 *  o 2000-00-00  
 *
 -----------------------------------------
 */

#include <ansi.h>
#include <map.h>
#include <daemon.h>
#include <feature.h>
#include <message.h>

inherit ROOM_ACTION_MOD;

private void input_mail_confirm(object me, string receiver, string title, string content, string yn)
{
	int time;
	mapping maildata;
	string file;

	if( yn != "y" && yn != "yes " )
	{
		tell(me, "HXHC\n");
		return me->finish_input();
	}
	
	time = time();
	file = read_file(user_mail(receiver));
	
	if( stringp(file) )
		maildata = restore_variable(file);
	
	if( !mapp(maildata) )
		maildata = allocate_mapping(0);
		
	// קK key 
	while( !undefinedp(maildata[time]) ) time++;
	
	maildata[time] = allocate_mapping(0);
	
	maildata[time]["time"] = time();
	maildata[time]["sender"] = me->query_id(1);
	maildata[time]["receiver"] = receiver;
	maildata[time]["title"] = kill_repeat_ansi(title+NOR);
	maildata[time]["content"] = kill_repeat_ansi(content+NOR);
	
	tell(me, "\HXu"+title+"vHC\n");
	
	me->finish_input();

	if( find_player(receiver) )
		tell(find_player(receiver), HIY"\nl@ʨӦ"+me->query_idname()+"HADu"+title+"vC\n"NOR);

	set_temp("postoffice", time, me);

	write_file(user_mail(receiver), save_variable(maildata), 1);
}

private void input_mail_content(object me, string receiver, string title, string content)
{
	if( !content || !content[0] )
	{
		tell(me, GRN"пJ"HIG"H󤺮eG\n"NOR);
		me->edit( (: input_mail_content, me, receiver, title :) );
		return;
	}

	tell(me, "TwHXHH(y/n)");
	input_to( (: input_mail_confirm, me, receiver, title, content :) );
}

private void input_mail_title(object me, string receiver, string title)
{
	if( !title || !title[0] )
	{
		tell(me, GRN"пJ"HIG"HDG"NOR);	
		input_to( (: input_mail_title, me, receiver :) );
		return;
	}
	if( noansi_strlen(title) > 40 )
	{
		tell(me, HIR"DDoWL 40 ӦrC\n"NOR);
		tell(me, GRN"пJ"HIG"HDG"NOR);	
		input_to( (: input_mail_title, me, receiver :) );
		return;
	}
	
	tell(me, GRN"пJ"HIG"H󤺮eG\n"NOR);
	
	me->edit( (: input_mail_content, me, receiver, title :) );
}

// HXH
private void do_mail(object me, string arg)
{
	if( !arg )
		return tell(me, "пJH IDC\n");
	
	if( !wizardp(me) && query_temp("postoffice", me) + 60 > time() )
		return tell(me, pnoun(2, me)+"[e~HXHAеy@C\n");

	if( !user_exists(arg) )
		return tell(me, "oӥ@ɤäsboӪaC\n");
		
	tell(me, GRN"пJ"HIG"HDG"NOR);
	
	input_to( (: input_mail_title, me, arg :) );
}


// CXH
private void do_list(object me, string arg)
{
	int i;
	string msg;
	string myid = me->query_id(1);
	string file = read_file(user_mail(myid));
	mapping maildata;
	
	if( !stringp(file) )
		return tell(me, pnoun(2, me)+"SHC\n");
		
	maildata = restore_variable(file);
	
	if( !mapp(maildata) || !sizeof(maildata) )
		return tell(me, pnoun(2, me)+"SHC\n");
		
	msg = me->query_idname()+"HpUG\n";
	msg += WHT"wwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww\n"NOR;
	msg += "    HH                     A  DD\n";
	msg += WHT"wwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww\n"NOR;
	
	foreach(int time in sort_array(keys(maildata), -1))
	{
		msg += sprintf("%-4s%-14s%-17s%-6s%s\n", 
			++i+".",
			capitalize(maildata[time]["sender"]),
			HIC+TIME_D->replace_ctime(time)+NOR,
			maildata[time]["read"] ? HIG"wŪ"NOR : HIR"Ū"NOR,
			HIY+maildata[time]["title"])+NOR;
	}
	
	msg += WHT"wwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww\n"NOR;
	msg += HIW"ŪHGread 's'BRHGdelete 's' \n\n"NOR;

	me->more(msg);
}


// ŪH
private void do_read(object me, string arg)
{
	int i;
	int selected;
	string msg;
	string myid = me->query_id(1);
	string file = read_file(user_mail(myid));
	mapping maildata;
	
	if( !stringp(file) )
		return tell(me, pnoun(2, me)+"SHC\n");
		
	maildata = restore_variable(file);
	
	if( !mapp(maildata) || !sizeof(maildata) )
		return tell(me, pnoun(2, me)+"SHC\n");
		
	i = to_int(arg);
	
	if( i < 1 || i > sizeof(maildata) )
		return tell(me, "JHs~C\n");
	
	selected = sort_array(keys(maildata), -1)[i-1];
	
	msg =  "HH  G"+capitalize(maildata[selected]["sender"])+"\n";
	msg += "HG"+HIG+TIME_D->replace_ctime(maildata[selected]["time"])+NOR+"\n";
	msg += "HDDG"+HIY+maildata[selected]["title"]+NOR+"\n";
	msg += "H󤺮eG\n";
	msg += WHT"wwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww\n"NOR;
	msg += "\n"+maildata[selected]["content"]+"\n\n";
	msg += WHT"wwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww\n"NOR;
	
	me->more(msg);
	
	if( undefinedp(maildata[selected]["read"]) )
	{
		maildata[selected]["read"] = 1;
		write_file(user_mail(myid), save_variable(maildata), 1);
	}
}

// H
private void do_delete(object me, string arg)
{
	int i;
	string myid = me->query_id(1);
	string file = read_file(user_mail(myid));
	mapping maildata;
	
	if( !stringp(file) )
		return tell(me, pnoun(2, me)+"SHC\n");
		
	maildata = restore_variable(file);
	
	if( !mapp(maildata) || !sizeof(maildata) )
		return tell(me, pnoun(2, me)+"SHC\n");
		
	i = to_int(arg);
	
	if( i < 1 || i > sizeof(maildata) )
		return tell(me, "JHs~C\n");
	
	map_delete(maildata, sort_array(keys(maildata), -1)[i-1]);

	tell(me, "R "+i+" ʫH󧹲C\n");
	
	write_file(user_mail(myid), save_variable(maildata), 1);
}

// ]wؿvжA
nosave mapping action_info =
([
	"lobby"	:
	([
		"short"	: HIG"l"NOR GRN"jU"NOR,
		"help"	:
			([
"topics":
@HELP
    ljUtdҦlF~ȡC
HELP,

"mail":
@HELP
HHY쪱aAΪkpUG
  mail 'aID'		- HHY쪱a
HELP,

"read":
@HELP
HAΪkpUG
  read 2		- Ū 2 ʫH
HELP,

"list":
@HELP
CXҦHAΪkpUG
  list			- ܩҦHC
HELP,

"delete":
@HELP
NYӫHRAΪkpUG
  delete 2		- R 2 ʫH
HELP,
			]),
		"action":
			([
				"mail"		: (: do_mail :),
				"read"		: (: do_read :),
				"list"		: (: do_list :),
				"delete"	: (: do_delete :),
			]),
	]),
]);


// ]wؿv
nosave array building_info = ({
	
	// ؿvW
	HIG"l"NOR

	// }iؿv̤֩ж
	,1

	// ̤jۦPؿvƶq(0 N)
	,0

	// ؿvؿv, GOVERNMENT(F), ENTERPRISE(~), INDIVIDUAL(pH)
	,GOVERNMENT

	// ؿviؿvϰ, AGRICULTURE_REGION(A~), INDUSTRY_REGION(u~), COMMERCE_REGION(ӷ~)
	,AGRICULTURE_REGION | INDUSTRY_REGION | COMMERCE_REGION

	// }iO
	,"5000000"
	
	// ؿvռаO
	,0

	// ca^m
	,30
	
	// ̰i[\Ӽh
	,1
	
	// ̤jۦPؿvƶq(0 N)
	,0
	
	// ؿvɥN
	,1
});

