/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : stock.c
 * Author : Clode@RevivalWorld
 * Date   : 2005-05-31
 * Note   : Ҩ
 * Update :
 *  o 2000-00-00  
 *
 -----------------------------------------
 */

#include <ansi.h>
#include <map.h>
#include <feature.h>
#include <message.h>
#include <daemon.h>
#include <npc.h>

inherit ROOM_ACTION_MOD;

#define PROCEDURE_FUND	50		// 2/100 O
#define MAX_OWN_STOCK_TYPE 10		// ̤jiPɫѲ

string stockvalue_change_description(float change)
{
	change = to_float(change);

	if( change > 0 )
		return sprintf(HIR"%5.2f"NOR, change);
	else if( change < 0 )
		return sprintf(HIG"%5.2f"NOR, -change);
	else
		return sprintf(HIW"  %5.2f"NOR, change);
}


void do_list(object me, string arg)
{
	int i, sort;
	string amount, totalvalue;
	float value;
	string enterprise;
	string sortdesc;
	mapping data;
	string *enterprise_stockvalue_sort;
	string msg = "~W                   ѻ ƦW ̷s^   iʱi   ثe  Ѫѻ  ` \n";
	msg += "wwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww\n";

	enterprise_stockvalue_sort = sort_array(ENTERPRISE_D->query_all_enterprises(), (: ENTERPRISE_D->query_enterprise_info($2, "stockvalue") > ENTERPRISE_D->query_enterprise_info($1, "stockvalue") ? 1 : -1 :));
		
	foreach(enterprise in ENTERPRISE_D->query_all_enterprises())
	{
		data = ENTERPRISE_D->query_enterprise_info(enterprise);
		
		value = to_float(query("stock/"+enterprise+"/value", me));
		amount = query("stock/"+enterprise+"/amount", me);
		totalvalue = count(count(amount, "*", to_int(value*1000000)), "/", 100);
		
		sort = member_array(enterprise, enterprise_stockvalue_sort)+1;
		
		switch(sort)
		{
			case 1: 	sortdesc = HIY BLINK + sort + NOR; break;
			case 2..10: 	sortdesc = HIY+ sort + NOR; break;
			default: 	sortdesc = NOR YEL + sort +NOR; break;
		}
				
		msg += sprintf("%-3d %-20s%7.2f %-4s %-8s %10s %10s   %7.2f  %s\n",
			++i,
			data["color_id"], 
			data["stockvalue"], 
			sortdesc,
			stockvalue_change_description(data["stockvalue_change"]),
			NUMBER_D->number_symbol(data["available_stockamount"]),
			NUMBER_D->number_symbol(amount),
			value,
			NUMBER_D->number_symbol(totalvalue)
			);
	}
	msg += "wwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww\n";
	msg += "Ѳ쬰 10,000 /iAO 2%AѥC 10 ܰʤ@\n\n";
	
	
	return me->more(msg);
}

void confirm_buystock(object me, string enterprise, string cost, string cost_extra, string new_amount, float new_value, float cur_value, int amount, string new_available_stockamount, float percent, string arg)
{
	if( !arg )
		return me->finish_input();
		
	arg = lower_case(arg);
	
	if( arg != "y" && arg != "yes" )
	{
		tell(me, "ʤJѲC\n");
		return me->finish_input();
	}

	if( !me->spend_money(MONEY_D->query_default_money_unit(), count(cost, "+", cost_extra)) )
	{
		tell(me, pnoun(2, me)+"WS "+money(MONEY_D->query_default_money_unit(), count(cost, "+", cost_extra))+"C\n");
		return me->finish_input();
	}
	
	set("stock/"+enterprise+"/amount", new_amount, me);
	set("stock/"+enterprise+"/value", new_value, me);
		
	ENTERPRISE_D->set_enterprise_info(enterprise, "available_stockamount", new_available_stockamount);
	CHANNEL_D->channel_broadcast("stock", me->query_idname()+"H "+sprintf("%.2f", cur_value)+" ѻʤJ"+ENTERPRISE_D->query_enterprise_color_id(enterprise)+"Ѳ "+NUMBER_D->number_symbol(amount)+" iAѤҤɬ "+sprintf("%.2f", percent)+"%");
	me->finish_input();
	
	TOP_D->update_top_stock(me);
	me->save();
}

void do_buystock(object me, string arg)
{
	int i, num, amount;
	string enterprise;
	mapping data;
	float old_value;
	float new_value;
	float cur_value;
	string old_amount;
	string new_amount;
	string new_available_stockamount;
	float percent;
	string cost;
	string cost_extra;
	
	if( !arg || sscanf(arg, "%d %d", num, amount) != 2 )
		return tell(me, "пJT榡C\n");

	if( num <= 0 || amount <= 0 )
		return tell(me, "пJj 0 ƦrC\n");

	i=0;
	foreach(enterprise in ENTERPRISE_D->query_all_enterprises())
	{
		if( ++i != num ) continue;
		
		data = ENTERPRISE_D->query_enterprise_info(enterprise);
		
		if( wizardp(me) )
		{
			if( !SECURE_D->is_wizard(data["president"]) )
				return tell(me, "ʶRѲ|ɭPY~QyzwAŮvuʶRŮvҫإߪ~ѲC\n");
		}
		else if( SECURE_D->is_wizard(data["president"]) )
			return tell(me, "LkʶRŮvإߪ~ѲC\n");
		
		if( count(amount, ">", data["available_stockamount"]) )
			return tell(me, "ثeiʶRiƥu "+NUMBER_D->number_symbol(data["available_stockamount"])+" iC\n");
			
		new_available_stockamount = count(data["available_stockamount"], "-", amount);

		cost = count(count(amount, "*", to_int(data["stockvalue"]*1000000)), "/", 100);
		cost_extra = count(cost, "/", PROCEDURE_FUND);

		old_amount = query("stock/"+enterprise+"/amount", me);
		new_amount = count(amount, "+", old_amount);
		
		cur_value = data["stockvalue"];
		old_value = to_float(query("stock/"+enterprise+"/value", me));
		new_value = to_float(count(count(count(to_int(old_value*1000000), "*", old_amount), "+", count(to_int(cur_value*1000000), "*", amount)), "/", new_amount))/1000000.;
		
		percent = to_float(count(count(new_amount, "*", 10000), "/", data["stockamount"]))/100.;
		
		if( !wizardp(me) && percent > 20 )
			return tell(me, "ӤHѤҤoWL 20%C\n");
		
		if( sizeof(query("stock", me)) >= MAX_OWN_STOCK_TYPE )
		{
			if( undefinedp(query("stock/"+enterprise, me)) )
				return tell(me, "PɫѺoWL "+MAX_OWN_STOCK_TYPE+" ءC\n");
		}
		tell(me,
			HIY"Ѳثeѻ  "NOR YEL+sprintf("%.2f", cur_value)+"\n"
			HIY"ѶRJ  "NOR YEL+sprintf("%.2f", old_value)+"\n"
			HIY"  "NOR YEL+sprintf("%.2f", new_value)+"\n"
			HIY"ʪѲi  "NOR YEL+NUMBER_D->number_symbol(amount)+"\n"
			HIY"ʪѲ`  "NOR YEL+money(MONEY_D->query_default_money_unit(), cost)+"\n"
			HIY"O  "NOR YEL+money(MONEY_D->query_default_money_unit(), cost_extra)+" (2%)\n"
			HIY"ʤJ`@O  "NOR YEL+money(MONEY_D->query_default_money_unit(), count(cost, "+", cost_extra))+"\n"
			HIY"ѤҤɬ  "NOR YEL+sprintf("%.2f", percent)+"%\n"
			HIY"O_TwʤJѲ?"NOR YEL"(Yes/No)"NOR
		);

		input_to((: confirm_buystock, me, enterprise, cost, cost_extra, new_amount, new_value, cur_value, amount, new_available_stockamount, percent :));
			
		return;
	}
	
	tell(me, "èSoӽsѲC\n");
}

void confirm_sellstock(object me, string enterprise, string earn, string earn_extra, string new_amount, float old_value, float cur_value, int amount, string new_available_stockamount, float percent, string arg)
{
	if( !arg )
		return me->finish_input();
		
	arg = lower_case(arg);
	
	if( arg != "y" && arg != "yes" )
	{
		tell(me, "cѲC\n");
		return me->finish_input();
	}
	
	me->earn_money(MONEY_D->query_default_money_unit(), count(earn, "-", earn_extra));
	
	if( count(new_amount, "<=", 0) )
		delete("stock/"+enterprise, me);
	else
		set("stock/"+enterprise+"/amount", new_amount, me);
		
	ENTERPRISE_D->set_enterprise_info(enterprise, "available_stockamount", new_available_stockamount);
	CHANNEL_D->channel_broadcast("stock", me->query_idname()+"H "+sprintf("%.2f", cur_value)+" ѻX"+ENTERPRISE_D->query_enterprise_color_id(enterprise)+"Ѳ "+NUMBER_D->number_symbol(amount)+" iAѤҭ "+sprintf("%.2f", percent)+"%");	
	me->finish_input();
	
	TOP_D->update_top_stock(me);
	me->save();
}

void do_sellstock(object me, string arg)
{
	int i, num, amount;
	string old_amount;
	string new_amount;
	float cur_value;
	float old_value;
	string earn;
	string earn_extra;
	float percent;
	string enterprise;
	mapping data;
	string new_available_stockamount;

	if( !arg || sscanf(arg, "%d %d", num, amount) != 2 )
		return tell(me, "пJT榡C\n");

	if( num <= 0 || amount <= 0 )
		return tell(me, "пJj 0 ƦrC\n");
	
	i=0;
	foreach(enterprise in ENTERPRISE_D->query_all_enterprises())
	{
		if( ++i != num ) continue;
		
		data = ENTERPRISE_D->query_enterprise_info(enterprise);
		
		old_amount = copy(query("stock/"+enterprise+"/amount", me));
		new_amount = count(old_amount, "-", amount);
		
		if( count(amount, ">", old_amount) )
			return tell(me, pnoun(2, me)+"ثe֦"+data["color_id"]+"Ѳiƥu "+NUMBER_D->number_symbol(old_amount)+" iC\n");
			
		new_available_stockamount = count(data["available_stockamount"], "+", amount);
		
		cur_value = data["stockvalue"];
		old_value = to_float(query("stock/"+enterprise+"/value", me));
		earn = count(count(amount, "*", to_int(cur_value*1000000)), "/", 100);
		earn_extra = count(earn, "/", PROCEDURE_FUND);
		
		percent = to_float(count(count(new_amount, "*", 10000), "/", data["stockamount"]))/100.;

		tell(me,
			HIY"Ѳثeѻ  "NOR YEL+sprintf("%.2f", cur_value)+"\n"
			HIY"ѥ  "NOR YEL+sprintf("%.2f", old_value)+"\n"
			HIY"Ѳi  "NOR YEL+NUMBER_D->number_symbol(amount)+"\n"
			HIY"Ѳ`  "NOR YEL+money(MONEY_D->query_default_money_unit(), earn)+"\n"
			HIY"O  "NOR YEL+money(MONEY_D->query_default_money_unit(), earn_extra)+" (2%)\n"
			HIY"X`@o  "NOR YEL+money(MONEY_D->query_default_money_unit(), count(earn, "-", earn_extra))+"\n"
			HIY"Ѥҭ  "NOR YEL+sprintf("%.2f", percent)+"%\n"
			HIY"O_TwXѲ?"NOR YEL"(Yes/No)"NOR
		);
		
		//tell(me, "O_TwH "+sprintf("%.2f", cur_value)+" ѻX"+data["color_id"]+"Ѳ "+NUMBER_D->number_symbol(amount)+" i\no "+money(MONEY_D->query_default_money_unit(), earn)+"AѤұN "+sprintf("%.2f", percent)+"%(Yes/No)G");
		
		input_to((: confirm_sellstock, me, enterprise, earn, earn_extra, new_amount, old_value, cur_value, amount, new_available_stockamount, percent :));
			
		return;
	}
	
	tell(me, "èSoӽsѲC\n");
}


// ]wؿvжA
nosave mapping action_info =
([
	"hall"	:
	([
		"short"	: NOR HIW"ҤjU"NOR,
		"help"	:
			([
"topics":
@HELP
    ҨaC
HELP,

"list":
@HELP
ܪѥT
list		CXҦѥ
HELP,

"buy":
@HELP
RJѲO
buy 2 300	RJ 2 ӪѲ 300 i
HELP,

"sell":
@HELP
XѲO
sell 3 100	X 3 ӪѲ 100 i
HELP,
			]),
		"heartbeat":0,	// ڮɶ 1 
		"job": 0,
		"action":
			([
				"list" : (: do_list :),
				"buy" : (: do_buystock :),
				"sell" : (: do_sellstock :),
			]),
	]),
]);


// ]wؿv
nosave array building_info = ({
	
	// ؿvW
	HIG"Ҩ"NOR GRN""NOR

	// }iؿv̤֩ж
	,2

	// ̤jۦPؿvƶq(0 N)
	,5

	// ؿvؿv, GOVERNMENT(F), ENTERPRISE(~), INDIVIDUAL(pH)
	,ENTERPRISE

	// ؿviؿvϰ, AGRICULTURE_REGION(A~), INDUSTRY_REGION(u~), COMMERCE_REGION(ӷ~)
	,COMMERCE_REGION

	// }iO
	,"75000000"
	
	// ؿvռаO
	,0

	// ca^m
	,0
	
	// ̰i[\Ӽh
	,1
	
	// ̤jۦPؿvƶq(0 N)
	,0
	
	// ؿvɥN
	,1
});
