/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : store.c
 * Author : Clode@RevivalWorld
 * Date   : 2002-4-13
 * Note   : Ҳ - @ө
 * Update :
 *  o 2000-00-00  
 *
 -----------------------------------------
 */

#include <npc.h>
#include <ansi.h>
#include <map.h>
#include <feature.h>
#include <daemon.h>
#include <message.h>
#include <condition.h>

inherit ROOM_ACTION_MOD;

inherit __DIR__"inherit/_object_database_mod.c";
inherit __DIR__"inherit/_action_import.c";
inherit __DIR__"inherit/_action_export.c";
inherit __DIR__"inherit/_action_list.c";
inherit __DIR__"inherit/_action_buy.c";
inherit __DIR__"inherit/_action_sell.c";
inherit __DIR__"inherit/_action_gain.c";
inherit __DIR__"inherit/_action_setup.c";
inherit __DIR__"inherit/_action_transport";
inherit __DIR__"inherit/_heart_beat_store.c";
inherit __DIR__"inherit/_action_auction";

#define	POBJECT		0
#define PSHORT		1
#define PIDNAME		2
#define PAMOUNT		3
#define PPRICE		4

#define STORE_CAPACITY	100000

void do_gowork(object me, string arg)
{
	object env = environment(me);
	object master = env->query_master();
	
	if( !query_heart_beat(master) )
		CHANNEL_D->channel_broadcast("sys", me->query_idname()+"խ״_ "+base_name(master)+" өD(l߸ "+query_heart_beat(master)+")");
		
	master->startup_heart_beat();

	msg("$ME@l⥴uGuڥΤOu@IIv\n", me, 0, 1);
}

void do_confirm_sightsee(object me, object env, string moneyunit, mixed money, int directly, string arg)
{
	int floor = env->query_floor();

	if( !directly && lower_case(arg) != "y" && lower_case(arg) != "yes" )
	{
		tell(me, pnoun(2, me)+"IOCYC\n");
		me->finish_input();
		return;
	}

	if( !directly )
	{
		if( count(money, ">", 0) && !me->spend_money(moneyunit, money) )
			return tell(me, pnoun(2, me)+"WICOΡC\n");
		else
		{
			msg("$MEIF $"+moneyunit+" "+NUMBER_D->number_symbol(money)+" COΡC\n", me, 0, 1);
			set("money", copy(count(query("money", env),"+",money)), env);
			env->save();
		}
	}

	msg("$MEqѤjӪ"HIW"["WHT"x"NOR"~sAu"HIC""NOR CYN""NOR"ƶhb|gAjǤJA``l@fAPıeF\hC\n", me, 0, 1);

	if( floor == 100 )
       		me->start_condition(SIGHTSEEBLESS);
       	else if( floor == 120 )
       		me->start_condition(SIGHTSEEBLESS_ADV1);	
       	else if( floor == 140 )
       		me->start_condition(SIGHTSEEBLESS_ADV2);	
       	else if( floor == 160 )
       		me->start_condition(SIGHTSEEBLESS_ADV3);
}

void do_sightsee(object me, string arg)
{
	object env = environment(me);
	string city = env->query_city();
	string moneyunit = MONEY_D->city_to_money_unit(city);
	mixed money = query("sightseeing_price", env);
	
	if( count(money, ">", 0) && me->query_id(1) != query("owner", env) )
	{
		tell(me, pnoun(2, me)+"C@ݤI $"+moneyunit+" "+NUMBER_D->number_symbol(money)+" OΡC\nO_TwnIOCH(Yes/No)G\n");
		input_to((: do_confirm_sightsee, me, env, moneyunit, money, 0 :));
	}
	else
		do_confirm_sightsee(me, env, moneyunit, money, 1, "y");
}

void do_scenery_setup(object me, string arg)
{
	int money;
	object env = environment(me);
	string moneyunit = MONEY_D->city_to_money_unit(env->query_city());

	if( !arg )
		return tell(me, "ثeCOά $"+moneyunit+" "+NUMBER_D->number_symbol(query("sightseeing_price", env))+"C\n");
	
	if( me->query_id(1) != query("owner", env) )
		return tell(me, pnoun(2, me)+"Oؿv̡֦C\n");

	money = to_int(arg);
		
	if( !money )
	{
		set("sightseeing_price", 0, env);
		msg("$MEN[xCOνվ㬰KOC\n", me, 0, 1);
		env->save();
		return;
	}
	
	if( money <= 0 )
		return tell(me, "пJTƭȡC\n");

	if( money > 100000000 )
		return tell(me, "̤jOΤoWL $"+moneyunit+" "+NUMBER_D->number_symbol(100000000)+"C\n");

	set("sightseeing_price", money, env);
	
	msg("$MEN[xCOνվ㬰 $"+moneyunit+" "+NUMBER_D->number_symbol(arg)+"C\n", me, 0, 1);
	env->save();
}

// ]wؿvжA
nosave mapping action_info =
([
	"front"	:
	([
		"short"	: HIC""NOR,
		"help"	: 
			([ 
"topics":
@HELP
    Oc⪱aӫ~aAPɥiHʯSwӫ~C
HELP,

"import":
@HELP
Nӫ~W[OAΪkpUG[޲zO]
  import all		- NҦWӫ~W[
  import all rice	- NҦ rice ӫ~W[
  import 3 rice		- N 3  rice ӫ~W[
  import rice		- N 1  rice ӫ~W[
HELP,

"export":
@HELP
Nӫ~U[OAΪkpUG[޲zO]
  export all		- NҦӫ~U[
  export all rice	- NҦ rice ӫ~U[
  export 3 rice		- N 3  rice ӫ~U[
  export rice		- N 1  rice ӫ~U[
  export 3 1		- N 3 s 1 ӫ~U[
  export 2		- N 1 s 2 ӫ~U[
HELP,

"list":
@HELP
CXҦc椤ӫ~OAΪkpUG
  list			- CXҦc椤ӫ~
HELP,

"buy":
@HELP
ʶRӫ~OAΪkpUG
  buy all rice			- RUҦ rice ӫ~
  buy 3 rice			- RU 3  rice ӫ~
  buy rice			- RU 1  rice ӫ~
  buy 3 2			- RU 3 s 2 ӫ~
  buy 2				- RU 1 s 2 ӫ~
  buy rice to center 1 51,22	- RU 1  rice ӫ~ðeF center  1 ìPy(51,22)Bؿv
HELP,

"gain":
@HELP
cӫ~ұoQAΪkpUG[޲zO]
  gain			- ҦQ
HELP,

"setup":
@HELP
]wө\઺OAΪkpUG[޲zO]
  setup mode				- u޲zҦvΡu~Ҧv
  
  setup sell				- ܥ@ɪ~CHΤ\cӫ~ƶqP
  setup sell all with 50%		- ]wҦ~ʻʤ 50%, ʼƶqL
  setup sell all with 50% for 100	- ]wҦ~ʻʤ 50%, wu 100 
  setup sell all -d			- ʩҦ~
  setup sell 2 with 50%			- ]w@ɪ~CWs 2 ~ʻ欰 50%, ʼƶqL
  setup sell 2 with 50% for 100		- ]w@ɪ~CWs 2 ~ʻ欰 50%,  100 
  setup sell 2 -d			- ʥ@ɪ~CWs 2 ӫ~

  setup price 2 120 			- ]ws 2 ӫ~欰 120
  setup price 2 150%			- ]ws 2 ӫ~欰 150%
  
  setup class 2 ~ 			- Ns 2 ӫ~쭹~[lWAiۭq
  setup class 2 PP			- 'PP'OөS[A즹[lWӫ~NiHɾPO
  setup class 2 i			- 'i'OөS[A즹[lWӫ~N¨ѮiܡALkX
HELP,

"sell":
@HELP
cӫ~OAΪkpUG
  sell			- ܥثe\cӫ~Pƶq
  sell all		- XҦWic檺ӫ~
  sell all rice		- XҦ rice ӫ~
  sell 3 rice		- X 3  rice ӫ~
HELP,

"transport":
@HELP
B骫~OAΪkpUG
  transport rice to 1 51,22	- N 1  rice ~Bܲ 1 ìPy(51,22)Bؿv
  transport 3 rice to 2 51,22	- N 3  rice ~Bܲ 2 ìPy(51,22)Bؿv
  transport 2 3 to 1 51,22	- N 2 s 3 ~B  1 ìPy(51,22)Bؿv
HELP,

"gowork":
@HELP
өɶc檫~ɡAiHϥΦOխ״_D
  gowork		- ״_өW䧮c檫~D
HELP,

"auction":
@HELP
檫~OAΪkpUG

auction '~s' 'ƶq' $'' $'ʶR' 'ɶ'

Ҧp:
	
auction 1 500 $20000 $1000000 5		- s 1 ~ 500 ӡAл $20000A
					  ʶR $1000000Aɶ 5 p

ȳ@߬ $RW

HELP,

			]),
		"job"	: CLERK,
		"heartbeat":5,	// ڮɶ 1 
		"master":1,
		"action":
			([
				"import"	: (: do_import($1, $2, "products", STORE_CAPACITY) :),
				"export"	: (: do_export($1, $2, "products") :),
				"list"		: (: do_list($1, $2, "products", STORE_CAPACITY) :),
				"buy"		: (: do_buy($1, $2, "products", "ENVIRONMENT") :),
				"sell"		: (: do_sell($1, $2, "products", STORE_CAPACITY) :),
				"gain"		: (: do_gain($1, $2) :),
				"setup"		: (: do_setup($1, $2) :),
				"transport"	: (: do_transport($1, $2, "products") :),
				"auction"	: (: do_auction($1, $2, "products") :),
				"gowork"	: (: do_gowork($1, $2) :),
			]),
	]),

	"scenery":
	([
		"short"	: HIW"["WHT"x"NOR,
		"help"	: 
			([ 
"topics":
@HELP
    o̬OӤW[xARiHCC
HELP,

"sightsee":
@HELP
CO
  sightsee		- C
HELP,

"setup":
@HELP
Oγ]wO
  setup			- dݥثeO
  setup 1000		- ]wCOά 1000 
HELP,

"gain":
@HELP
QO
  gain			- ҦQ
HELP,

			]),
		"action":
			([
				"sightsee"	: (: do_sightsee :),
				"setup"		: (: do_scenery_setup :),
				"gain"		: (: do_gain :),
			]),
	]),
]);


string look_room(object room)
{
	string msg = "";
	object master = room->query_master();

	if( query("function", room) == "front" )
	{
		msg += "aR "HIC+query("shopping/desire", room)+NOR;
		msg += " R "HIC+query("shopping/average_desire", master)+NOR;
		msg += " P` "HIY+NUMBER_D->number_symbol(query("totalsell", master))+NOR;
		msg += " ޫO "HIG+query("shopping/security", master)+NOR;
		msg += " ө޲z "HIY+(sizeof(master->query_slave())+1)+"/"+query("shopping/management", master)+NOR"\n";
	}
	return msg;
}

// ]wؿv
nosave array building_info = ({
	
	// ؿvW
	HIC""NOR CYN""NOR

	// }iؿv̤֩ж
	,1

	// ̤jۦPؿvƶq(0 N)
	,0

	// ؿvؿv, GOVERNMENT(F), ENTERPRISE(~), INDIVIDUAL(pH)
	,INDIVIDUAL

	// ؿviؿvϰ, AGRICULTURE_REGION(A~), INDUSTRY_REGION(u~), COMMERCE_REGION(ӷ~)
	,AGRICULTURE_REGION | INDUSTRY_REGION | COMMERCE_REGION

	// }iO
	,"200000"
	
	// ؿvռаO
	,0

	// ca^m
	,5
	
	// ̰i[\Ӽh
	,300
	
	// ̤jۦPؿvƶq(0 N)
	,10
	
	// ؿvɥN
	,1
});
