/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : wiz_login_d.c
 * Author : Clode@RevivalWorld
 * Date   : 2000-12-29
 * Note   : ŮvnF
 * Update :
 *  o 2001-02-09 Clode R port k, i@ǵ{gk
 *  o 2001-07-20 Clode g repeat login id ˬd
 *
 -----------------------------------------
 */

#include <ansi.h>
#include <login.h>
#include <daemon.h>
#include <object.h>
#include <secure.h>
#include <mudlib.h>
#include <message.h>

#define INITIALIZE		1
#define INPUT_ID		2
#define INPUT_PASSWORD		3
#define RECONNECT		4
#define OLD_PLAYER		5
#define ENTER_GAME		6

private nomask varargs void logon_handle(int state, object ob, string arg)
{
	ob->reset_time_out(); // ]Time_outɶ

	if( arg && query("encode/gb", ob) ) arg = G2B(arg);
	
	switch(state)
	{
	/* ҩl Login */
	case INITIALIZE:
		{
			ob->directly_receive("Current charset is " + (query("encode/gb", ob) ? "Simplified Chinese (GB)":"Traditional Chinese (BIG5)") + "\n");
			ob->directly_receive("Please input GB/BIG5 to change charset or directly login user.\n");

			tell(ob, "zŮv^WrG", CLIENTIGNORE);
			input_to( (: logon_handle, INPUT_ID, ob :) );

			return;
		}
		
	/* J ID */
	case INPUT_ID:
		{	
			int level_num;
			
			if( !arg || arg == "" )
				return logon_handle(INITIALIZE, ob);
			
			arg = remove_ansi(remove_fringe_blanks(lower_case(arg)));
			
			if( arg == "gb" )
			{
				set("encode/gb", 1, ob);
				return this_object()->logon(ob);
			}
			else if( arg == "big5" )
			{
				delete("encode/gb", ob);
				return this_object()->logon(ob);
			}

			if( file_size(user_data(arg)) <= 0 )
			{
				tell(ob, "CS "+arg+" oŮvC\n", CONNECTFAILED);
				return logon_handle(INITIALIZE, ob);
			}
			
			level_num = SECURE_D->level_num(arg);
			
			if( level_num < GUEST )
			{
				tell(ob, HIG"uŮv~qs "+WIZ_PORT+" nJAaбq "+PPL_PORT+" nJC\n"NOR, CONNECTFAILED);
				return logon_handle(INITIALIZE, ob);
			}
			
			if( level_num < LOGIN_D->query_wiz_lock() )
			{
				tell(ob, HIY"tΧs@AثeȤ\vb "+SECURE_D->level_num_to_level_name(LOGIN_D->query_wiz_lock())+" HWϥΪ̳suC\n"NOR, CONNECTFAILED);
				return logon_handle(INITIALIZE, ob);
			}
			
			if( LOGIN_D->is_repeat_login(arg) )
			{
				tell(ob, "pzJ "+capitalize(arg)+" bQnAФŭеnC\n", CONNECTFAILED);
				return logon_handle(INITIALIZE, ob);
			}
			else
				set("id", arg, ob);

			tell(ob, "пJKXG", CLIENTIGNORE);
			input_to( (: logon_handle, INPUT_PASSWORD, ob :), 1 );
			return;           
		}

	/* JKX */
	case INPUT_PASSWORD:
		{
			string password = PASSWORD_D->query_password(query("id", ob));

			if( !arg || crypt(arg, password) != password )
			{
				tell(ob, "KXJ~C\n", CONNECTFAILED);
					
				if( LOGIN_D->input_wrong_password(ob) >= 3 )
				{
					tell(ob, "AwgJ~KXTAЭsnJAաC\n", CONNECTFAILED);
					destruct(ob); return;
				}
				
				tell(ob, "пJTKXG", CLIENTIGNORE);
				input_to( (: logon_handle, INPUT_PASSWORD, ob :), 1 ); return;
			}

			// YbCۦP ID ϥΪ̪
			if( find_player(query("id", ob)) )
			{
				set("player", find_player(query("id", ob)), ob);
				
				// Yʪ, h߰ݬO_N
				if( interactive(query("player", ob)) )
				{
					tell(ob, "AQNثebCۦPH(Y/N)H\n", CMDMSG);
					input_to( (: logon_handle, RECONNECT, ob :) );return;
				}
				// ssuN
				else
					logon_handle(RECONNECT, ob, "y");return;
			}

			/* KXˬdT, iJC */
			return logon_handle(OLD_PLAYER, ob);
		}

	/* ªan */
	case OLD_PLAYER:
		{
			object user_ob = load_user(query("id", ob));
			
			if( !objectp(user_ob) )
			{
				object login_ob = new(LOGIN_OB);
				
				tell(ob, "LkJ "+capitalize(query("id", ob))+" xsɡApŮvBzC\n", CONNECTFAILED);
				exec(login_ob, ob);
				destruct(ob);
				logon_handle(INITIALIZE, login_ob);return;
			}

			set_temp("login/ident", query("ident", ob), user_ob);
			set_temp("login/remoteport", query("remote_port", ob), user_ob);
			set_temp("login/terminaltype", query("terminaltype", ob), user_ob);
			set_temp("windowsize", query("windowsize", ob) || DEFAULT_WINDOW_SIZE, user_ob);

			if( query("encode/gb", ob) )
				set("encode/gb", 1, user_ob);
			else
				delete("encode/gb", user_ob);

			//  LOGIN_OB  USER_OB
			exec( user_ob , ob );
			destruct(ob);

			return logon_handle(ENTER_GAME, user_ob);
		}

	/* ssu */
	case RECONNECT:
		{
			object reconnect_ob;
			
			if( !arg || remove_ansi(remove_fringe_blanks(lower_case(arg))) != "y" )
			{
				tell(ob, "zMwNCۦPHC\n", CONNECTFAILED);
				ob->reset_database();
				
				logon_handle(INITIALIZE, ob);return;
			}

			if( !objectp(reconnect_ob = query("player", ob)) )
			{
				tell(ob, "쥻CHwgAЭsnJC\n", CONNECTFAILED);
				ob->reset_database();
				logon_handle(INITIALIZE, ob);return;
			}
				
			if( !interactive(reconnect_ob) )
				reconnect_ob->reconnect();
			else
			{
				object temp = new(VOID_OB);
				
				tell(reconnect_ob, "t~@ϥΪ̦ "+query_ip_name(ob)+" suNFAC\n", ETCMSG);
				
				/* N쥻aഫܤ@ӼȮ USER_OB ANR */
				exec(temp, reconnect_ob);
				destruct(temp);
			}

			set_temp("reconnect", 1, reconnect_ob);
			set_temp("login/ident", query("ident", ob), reconnect_ob);
			set_temp("login/remoteport", query("remote_port", ob), reconnect_ob);
			set_temp("windowsize", query("windowsize", ob) || DEFAULT_WINDOW_SIZE, reconnect_ob);
			set_temp("login/terminaltype", query("terminaltype", ob), reconnect_ob);

			if( query("encode/gb", ob) )
				set("encode/gb", 1, reconnect_ob);
			else
				delete("encode/gb", reconnect_ob);

			/* N user_ob */
			exec( reconnect_ob , ob );
			destruct(ob);

			return logon_handle(ENTER_GAME, reconnect_ob);
		}

	/* iJC */
	case ENTER_GAME:
		{	
			// iJC
			LOGIN_D->enter_game(ob);
			return;

		}/* ENTER_GAME */

	default: return logon_handle(INITIALIZE, ob);
	
	}/* END SWITCH */
}

void wait_for_login(object login_ob, string arg)
{
	tell(login_ob, "JAеy ...\n", CMDMSG);
	input_to( (: wait_for_login, login_ob :) );
}
nomask void logon(object login_ob)
{
	/* Jt */
	if( !SYSTEM_D->valid_login() )
	{
		tell(login_ob, HIY + MUD_FULL_NAME + "JAеy ...\n"NOR, CMDMSG);
		SYSTEM_D->add_loginuser( login_ob );
		input_to( (: wait_for_login, login_ob :) );
		return;
	}

	if( !LOGIN_D->check_login_attacker(query_ip_number(login_ob)) )
	{
		login_ob->directly_receive(HIR"\nܩpAo IP["+query_ip_number(login_ob)+"] nJʧ@ӹLWcAеyԦAաC\n"NOR);
		CHANNEL_D->channel_broadcast("sys", "nJG"+query_ip_number(login_ob)+" nJʧ@ӹLWc");
		destruct(login_ob);
		return;
	}

	LOGIN_D->show_login_message(login_ob);
	logon_handle(INITIALIZE, login_ob);
}
int remove()
{
	foreach(object user in users())
	{
		if( !user->is_login_ob() ) continue;
		tell(user, HIR"\nܩpAntΧsA·бzAsnC\n"NOR, CONNECTFAILED);
		flush_messages(user);
		destruct(user);
	}
}

string query_name()
{
	return "ŮvnJt(WIZ_LOGIN_D)";
}
