/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : message.c
 * Author : Clode@RevivalWorld
 * Date   : 2001-7-2
 * Note   : included by Simul_Efun Object
 * Update :
 *  o 2003-02-14 Clode TjT禡 tell(), broadcast(), msg()

 -----------------------------------------
 */

#include <location.h>
#include <message.h>
#include <daemon.h>

//
// write(), tell_object(), HT禡
//  tell() Bz, H䴩aϨtλP Client Tǿ
//
varargs void tell(mixed target, string msg, string classes)
{
	if( objectp(target) || arrayp(target) )
		target->catch_tell(msg, classes);
}

/* ҦϥΪ̩XT */
void shout(string msg)
{
	tell(filter_array(users(), (: !$1->is_login_ob() :)), msg, SYSMSG);
}

//
// say(), tell_room() hHT禡
//  broadcast() Bz, H䴩aϨtλP Client Tǿ
//
varargs void broadcast(mixed target, string msg, string classes, mixed exclude)
{
	object *receivers = allocate(0);

	if( !target ) return;

	if( stringp(target) )
		target = load_object(target);

	// sHY@Ӫ, h䤺ePPҪǰeT
	if( objectp(target) )
	{
		//object env = environment(target);

		//if( objectp(env) )
		//{
		//	if( env->is_maproom() )
		//		return broadcast(query_temp("location", target), msg, classes, exclude);

		//	receivers += all_inventory(env);
		//}
		receivers += all_inventory(target);
	}
	// YsHaϨtήy, hBzyйLo
	else if( arrayp(target) )
		receivers += MAP_D->coordinate_inventory(target);

	// ~H
	if( !undefinedp(exclude) )
	{
		if( arrayp(exclude) )
			receivers -= exclude;
		else if( objectp(exclude) )
			receivers -= ({ exclude });
	}

	// Ҧ̼sT
	tell(receivers, msg, classes);
}


/* Τ@NWഫToe禡 */
varargs void msg(string msg, object me, object you, int onlooker, string classes, object *exclude, mapping translate)
{
	string my_msg, your_msg;
	string my_idname, your_idname;

	if( !msg || !objectp(me) ) return;

	// o Me 
	my_idname = me->query_idname() || "LW";


	// B~Jrഫ, YF $ME P $YOU H~ഫ
	if( mapp(translate) )
		foreach(string pattern, string replace in translate)
		msg = replace_string(msg, pattern, replace);

	// Me TĤGHഫ
	my_msg = replace_string(msg, "$ME", pnoun(2, me));

	// YH you, h you @TBz
	if( objectp(you) )
	{
		your_idname = you->query_idname() || "LW";

		// Me TĤTHഫ
		my_msg = replace_string(my_msg, "$YOU", your_idname, 1);
		my_msg = replace_string(my_msg, "$YOU", pnoun(3, you));

		// You TĤGHഫ
		your_msg = replace_string(msg, "$ME", my_idname, 1);
		your_msg = replace_string(your_msg, "$ME", pnoun(3, me));
		your_msg = replace_string(your_msg, "$YOU", pnoun(2, you));


		// 磌 you eXT
		if( !arrayp(exclude) || member_array(you, exclude) == -1 )
			tell(you, your_msg, classes);
	}

	// 磌 Me eXT
	if( !arrayp(exclude) || member_array(me, exclude) == -1 )
		tell(me, my_msg, classes);

	// Y onlooker([) Ѽ, hP me  you P@ҤͪoXT
	if( onlooker )
	{
		string onlookers_msg;
		object *onlookers = present_objects(me) + ({environment(me)})||({});

		if( objectp(you) && environment(me) != environment(you) ) 
			onlookers += present_objects(you) + ({environment(you)})||({});

		onlookers -= ({ me, you }) + (exclude || ({}));

		onlookers_msg = replace_string(msg, "$ME", my_idname);

		if( objectp(you) ) 
			onlookers_msg = replace_string(onlookers_msg, "$YOU", your_idname);

		// Ҧ[̪eXT
		tell(onlookers, onlookers_msg, classes);
	}
}

void write(mixed args...)
{
	error("write() wgoϥ, Ч tell()");
}

void tell_object(mixed args...)
{
	error("tell_object() wgoϥ, Ч tell()");
}

void say(mixed args...)
{
	error("say() wgoϥ, Ч broadcast()");
}

void tell_room(mixed args...)
{
	error("tell_room() wgoϥ, Ч broadcast()");
}

void message(mixed args...)
{
	error("message() wgoϥ, Ч msg()");
}

void printf(string format, mixed args...)
{
	efun::printf("printf():\n"+format, args...);
}
